/**
 * Author: Sergey Kopeliovich (Burunduk30@gmail.com)
 * Date: 2014.08.03
 * OK, 0.030 sec, 4 mb (1.6 + stack)
 */

#include <cstdio>
#include <cassert>
#include <algorithm>
#include <iostream>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)

typedef pair <int, int> pii;
typedef long long ll;

const int N = 1e5;

ll sum;
int n;
pii a[2 * N];

pii get( int l, int r ) {
  pii m = a[l + n];
  for (l += n, r += n; l <= r; l >>= 1, r >>= 1) {
    if ((l & 1) == 1) m = min(m, a[l++]);
    if ((r & 1) == 0) m = min(m, a[r--]);
  }
  return m;                   
}

void solve( int l, int r ) {
  if (l > r)
    return;
  pii p = get(l, r);
  int i = p.second;
  sum += (ll)(i - l + 1) * (r - i + 1) * p.first;
  solve(l, i - 1);
  solve(i + 1, r);
}

int main() {
  #define NAME "minsum"
  assert(freopen(NAME ".in", "r", stdin));
  assert(freopen(NAME ".out", "w", stdout));

  assert(scanf("%d", &n) == 1 && n <= N);
  forn(i, n)
    scanf("%d", &a[i + n].first), a[i + n].second = i;
  for (int i = n - 1; i > 0; i--)
    a[i] = min(a[2 * i], a[2 * i + 1]);
  solve(0, n - 1);
  cout << sum << endl;
  return 0;
}
