/** OK, 0.791, 41 mb */

#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <vector>
#include <algorithm>

using namespace std;

#define MP make_pair
#define Y first
#define X second
#define PB push_back
typedef pair <int, int> PII;
                        
#define maxn 200013

int res = 0, n, w, h, clen[maxn];
PII rp, p[maxn];
vector <int> y;

struct segment
{
  int i, x, len;
  segment() {}
  segment( int _i, int _x, int _len ) { i = _i, x = _x, len = _len; }
};
struct tree
{
  int y, mlen;
  segment s;
  tree *l, *r;
};

#define maxt 1000010
tree tmem[maxt];
int tpos;

tree *NewT( segment s, int y )
{
  tmem[tpos].l = tmem[tpos].r = 0;
  tmem[tpos].s = s;
  tmem[tpos].y = y;
  return &tmem[tpos++];
}

void Calc( tree *t )
{
  if (!t)
    return;
  t->mlen = t->s.len;
  if (t->l) 
    if (t->mlen < t->l->mlen)
      t->mlen = t->l->mlen;
  if (t->r)
    if (t->mlen < t->r->mlen)
      t->mlen = t->r->mlen;
}

bool operator == ( const segment &a, const segment &b )
{
  return MP(a.x, MP(a.len, a.i)) == MP(b.x, MP(b.len, b.i));
}

bool operator < ( const segment &a, const segment &b )
{
  return MP(a.x, MP(a.len, a.i)) < MP(b.x, MP(b.len, b.i));
}

void Split( tree *t, tree **l, tree **r, segment s )
{
  if (!t)
    *l = *r = 0;
  else if (s < t->s)
    Split(t->l, l, &t->l, s), *r = t;
  else
    Split(t->r, &t->r, r, s), *l = t;
  Calc(*l), Calc(*r);
}

void Add( tree **t, segment s, int y )
{
  clen[s.i] = s.len;
  if (*t == 0)
    *t = NewT(s, y);
  else if ((*t)->y < y)
    if (s < (*t)->s)
      Add(&(*t)->l, s, y);
    else
      Add(&(*t)->r, s, y);
  else
  {
    tree *p = NewT(s, y);
    Split(*t, &p->l, &p->r, s);
    *t = p;
  }
  Calc(*t);
}

void Merge( tree **t, tree *l, tree *r )
{
  if (!l)
    *t = r;
  else if (!r)
    *t = l;
  else if (l->y < r->y)
    *t = l, Merge(&(*t)->r, (*t)->r, r);
  else
    *t = r, Merge(&(*t)->l, l, (*t)->l);
  Calc(*t);
}

void Del( tree **t, segment s )
{
  if ((*t)->s == s)
  {
    tree *p;
    Merge(&p, (*t)->l, (*t)->r);
    *t = p;
  }
  else if (s < (*t)->s)
    Del(&(*t)->l, s);
  else
    Del(&(*t)->r, s);
  Calc(*t);
}

tree *Find( tree *t, int x )
{
  if (!t)
    return t;
  if (t->s.x <= x)
  {
    tree *p = Find(t->r, x);
    if (!p || p->s.x > x)
      return t;
    return p;
  }
  return Find(t->l, x);
}

tree *FindI( tree *t, segment s )
{
  if (!t || t->s.i == s.i)
    return t;
  if (t->l && s < t->s)
    return FindI(t->l, s);
  tree *p = FindI(t->r, s);
  if (!p || p->s.x > s.x)
    return t;
  return p;
}

tree *Get( tree *t, int ma )
{
  if (t->mlen < ma)
    if (t->l && t->l->mlen == t->mlen)
      return Get(t->l, ma);
    else if (t->s.len == t->mlen)
      return t;
    else
      return Get(t->r, ma);
  else
    if (t->l && t->l->mlen >= ma)
      return Get(t->l, ma);
    else if (t->s.len >= ma)
      return t;
    else
      return Get(t->r, ma);
}

#define RAND ((rand() << 15) + rand())

void Type( tree *t )
{
  if (!t)
    return;
  Type(t->l);
  fprintf(stderr, "x=%d len=%d i=%d\n", t->s.x, t->s.len, t->s.i);
  Type(t->r);
}

void Solve( void )
{
  int i = 0, j = 0, ymi = 0, yma = p[0].Y, len;
  tree *tr = 0, *tmp;
  tpos = 0;

  p[n].Y = h;
  p[n + 1].X = 0;
  Add(&tr, segment(n + 1, 0, w), RAND);

  tmp = Get(tr, yma - ymi);
  int ma = tmp->s.len, xma = tmp->s.x;
  if (ma > yma - ymi)
    ma = yma - ymi;
  if (ma > res || (ma == res && rp > MP(xma, ymi)))
    res = ma, rp = MP(xma, ymi);
  do
  {
    tmp = Find(tr, p[j].X);
    Del(&tr, tmp->s);
    Add(&tr, segment(j, p[j].X, tmp->s.len - (p[j].X - tmp->s.x)), RAND);
    tmp->s.len = p[j].X - tmp->s.x;
    Add(&tr, tmp->s, RAND);
    yma = p[++j].Y;

    while (1)
    {
      tmp = Get(tr, yma - ymi);
      int ma = tmp->s.len, xma = tmp->s.x;
      if (ma > yma - ymi)
        ma = yma - ymi;
      if (ma > res || (ma == res && rp > MP(xma, ymi)))
        res = ma, rp = MP(xma, ymi);
      if (tr->mlen > yma - ymi || (!tr->l && !tr->r))
        break;

      tmp = FindI(tr, segment(i, p[i].X, clen[i])), len = tmp->s.len;
      Del(&tr, tmp->s);
      tmp = FindI(tr, segment(i, p[i].X, clen[i]));
      Del(&tr, tmp->s);
      tmp->s.len += len;
      Add(&tr, tmp->s, RAND);
      ymi = p[i++].Y;
   }
  } while (j < n);
}

int main( void )
{
  int i;
  freopen("roi.in", "rt", stdin);
  freopen("roi.out", "wt", stdout);
  scanf("%d%d%d", &w, &h, &n);
  for (i = 0; i < n; i++)
    scanf("%d%d", &p[i].X, &p[i].Y), y.PB(p[i].Y);
  y.PB(0);
  sort(p, p + n);
  sort(y.begin(), y.end());
  memset(clen, 0, sizeof(clen));
  memset(tmem, 0, sizeof(tmem));

  Solve();
  printf("%d\n%d %d\n", res, rp.first, rp.second);
  return 0;
}
