#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <sstream>
#include <set>
#include <string>
#include <vector>

using namespace std;

typedef long long int64;
typedef double real;
const int MaxBuf = 524288;

char buf [MaxBuf];
char ch;

char * getstr (char * buf)
{
 if (fgets (buf, MaxBuf, stdin) == NULL)
  return NULL;
 for (int n = strlen (buf) - 1; n >= 0 &&
  (buf[n] == '\n' || buf[n] == '\t' || buf[n] == ' '); n--)
   buf[n] = '\0';
 return buf;
}

bool isempty (char * buf)
{
 return (strlen (buf) == 0);
}

typedef pair <int, int> tuple;

int main (int argc, char * argv [])
{
 set <tuple> p;
 int i, n, x, y;
 assert (argc > 1);
 freopen (argv[1], "rt", stdin);

 {
  assert (getstr (buf) != NULL);
  stringstream ssbuf (buf);
  assert (ssbuf >> x);
  assert (x >= 0 && x <= 1000000000);
  assert (ssbuf >> y);
  assert (y >= 0 && y <= 1000000000);
  assert (ssbuf.eof ());
 }

 {
  assert (getstr (buf) != NULL);
  stringstream ssbuf (buf);
  assert (ssbuf >> n);
  assert (n >= 0 && n <= 200000);
  assert (ssbuf.eof ());
 }

 for (i = 0; i < n; i++)
 {
  assert (getstr (buf) != NULL);
  stringstream ssbuf (buf);
  tuple a;
  assert (ssbuf >> a.first);
  assert (a.first >= 0 && a.first <= x);
  assert (ssbuf >> a.second);
  assert (a.second >= 0 && a.second <= y);
  assert (ssbuf.eof ());
  assert (p.find (a) == p.end ());
  p.insert (a);
 }
  
 assert (fscanf (stdin, " %c", &ch) == EOF);
 printf ("Correct.\n");
 return 0;
}
