//#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cmath>
using namespace std;
struct point{
  int x,y,kv;
  point(int _x=0,int _y=0){
   x=_x;y=_y;
   if(y>0 || (y==0 && x>=0))kv=0;
   else kv=1;
                          }
  bool operator<(const point& w)const{return ((kv!=w.kv)?kv<w.kv:((x*w
.y-w.x*y)>0));}
};
inline int vp(point f,point s){return (f.x*s.y-s.x*f.y);}
inline bool between(point f,point t,point w){return(vp(f,w)>=0 && vp(w
,t)>=0);}
// input
int n,l;
point F[50010],T[50010];int type[50010]; // 0-wall, 1-shot
struct data{ //the shots
  int ID;point D;
  data(){}
  data(point f){D=f;}
  data(int id){ID=id;D=F[id];}
  bool operator<(const data& w)const{return(D<w.D);}
};
data line[50010];
int back[50010];
double X[50010],Y[50010],BEST[50010];
double *pXE;
void read(){
  char BUF[10];
  int x1,y1,x2,y2;
  while(1){
   scanf("%s",&BUF);
   if(BUF[0]=='e')break;
   if(BUF[0]=='s'){
    type[n]=1;
    scanf("%d%d",&x1,&y1);F[n++]=point(x1,y1);
                  }
   if(BUF[0]=='w'){
    scanf("%d%d%d%d",&x1,&y1,&x2,&y2);
    F[n]=point(x1,y1);T[n]=point(x2,y2);
    if(vp(F[n],T[n])<0)swap(F[n],T[n]);
    ++n;
                  }
          }
  for(int i=0;i<n;++i)
   if(type[i]==1 && F[i].y!=0)line[l++]=data(i);
  sort(line,line+l);
  for(int i=0;i<l;++i)back[line[i].ID]=i;
  for(int i=0;i<l;++i){
   X[i]=line[i].D.x;Y[i]=line[i].D.y;
   BEST[i]=-1;
                      }
  pXE=X+l;
}
double a10=-1,am10=-1;
int main(){
  int i,j,k;
  //system("pause");
  read();
  long long sum = 0;
  for(i=0;i<n;++i){
   if(type[i]){ // a shot
    if(F[i].y==0){
     double U=a10;
     if(F[i].x<0)U=am10;
     if(U<0)printf("Infinite\n");
     else printf("%.9lf\n",fabs((1/U)/F[i].x));
                 }
    else{
     double U=BEST[back[i]];
     if(U<0)printf("Infinite\n");
     else printf("%.9lf\n",fabs(1/U));
        }
              }
   else{ // a wall
    double x1=F[i].x,y1=F[i].y,x2=T[i].x-x1,y2=T[i].y-y1;;
    double C=x2*y1-x1*y2;
    x2/=C;y2/=C;
    if(between(F[i],T[i],point(1,0)))a10=max(a10,-y2);
    if(between(F[i],T[i],point(-1,0)))am10=max(am10,y2);
    data *from,*to;
    from=lower_bound(line,line+l,data(point(F[i].x,F[i].y)));
    to=upper_bound(line,line+l,data(point(T[i].x,T[i].y)));
    if(F[i]<T[i]){
     double *pKX=X+(from-line),*pKE=X+(to-line),*pBEST=BEST+(from-line
),*pY=Y+(from-line);
     double A;
     for(;pKX!=pKE;++pKX,++pBEST,++pY){
      sum++;
      A=x2*(*pY)-y2*(*pKX);
      if(A>(*pBEST))*pBEST=A;
                                      }
                 }
    else{
     double *pKX=X+(from-line),*pKE=X+(to-line),*pBEST=BEST+(from-line
),*pY=Y+(from-line);
     double A;
     for(;pKX!=pXE;++pKX,++pBEST,++pY){
      sum++;
      A=x2*(*pY)-y2*(*pKX);
      if(A>(*pBEST))*pBEST=A;
                                      }  
     for(pKX=X,pBEST=BEST,pY=Y;pKX!=pKE;++pKX,++pBEST,++pY){
      sum++;
      A=x2*(*pY)-y2*(*pKX);
      if(A>(*pBEST))*pBEST=A;
                                                           } 
        }
       }
                  }
  //system("pause");
  fprintf(stderr, "sum = %I64d\n", sum);
  return 0;
}
