/**
 * Author: Sergey Kopeliovich (Burunduk30@gmail.com)
 * Date: 2012.10.19
 */

#define _USE_MATH_DEFINES

#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>

#include <algorithm>
#include <iostream>
#include <vector>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)

const int maxN = (int)5e4;
const int maxA = 1 << 18;
const double inf = 1e9;

char com[9];
int an, n, type[maxN], X1[maxN], Y1[maxN], X2[maxN], Y2[maxN];
double D1[maxN], D2[maxN];

double D( double x, double y ) { return sqrt(x * x + y * y); }

int main()
{
  for (n = 0; scanf("%s", com) == 1 && strcmp(com, "end"); n++)
    if (!strcmp(com, "shot"))
    {
      type[n] = 1;
      scanf("%d%d", &X1[n], &Y1[n]);

      double res = inf, t;
      forn(s, n)
        if (type[s] == 2)
        {
          int f1 = (X1[s] * Y1[n] - Y1[s] * X1[n] >= 0 && X2[s] * Y1[n] - Y2[s] * X1[n] <= 0);
          int f2 = (X1[s] * Y1[n] - Y1[s] * X1[n] <= 0 && X2[s] * Y1[n] - Y2[s] * X1[n] >= 0);
          if (!f1 && !f2)
            continue;

          if (X2[s] * Y1[s] - X1[s] * Y2[s] == 0)
            t = min(D1[s], D2[s]) / D1[n];
          else
          {
            double dx = X2[s] - X1[s], dy = Y2[s] - Y1[s];
            t = (X1[s] * dy - Y1[s] * dx) / (X1[n] * dy - Y1[n] * dx);
          }
          if (t > 0)
            res = min(res, t);
        }
      if (res == inf)
        puts("Infinite");
      else
        printf("%.20f\n", res);
    }
    else
    {
      type[n] = 2;
      scanf("%d%d", &X1[n], &Y1[n]);
      scanf("%d%d", &X2[n], &Y2[n]);
      D1[n] = D(X1[n], Y1[n]);
      D2[n] = D(X2[n], Y2[n]);
    }
  return 0;
}
