#include <cstdio>
#include <cmath>
#include <algorithm>

using namespace std;

#include "random.h"

#define forn(i, n) for (int i = 0; i < (int)(n); i++)

int main()
{
  initrand(239);

  int q1 = 8000;
  int R = 10000, r = 5000;
  double *a = new double[q1 + 1];

  forn(i, q1 + 1)
    a[i] = M_PI * ((double)i / q1);
  forn(i, q1)
  {
    printf("wall %.0lf %.0f %.0lf %.0lf\n", cos(a[i]) * r, sin(a[i]) * r, cos(a[i]) * R, sin(a[i]) * R);
    printf("wall %.0lf %.0f %.0lf %.0lf\n", cos(a[i + 1]) * r, sin(a[i + 1]) * r, cos(a[i]) * R, sin(a[i]) * R);
  }

  int q2 = 6499;
  forn(i, q2)
  {
    printf("wall %d %d %d %d\n", -R, i / 2, -((i + 1) / 2), R);
    printf("wall %d %d %d %d\n", R, i / 2, ((i + 1) / 2), R);
    printf("wall %d %d %d %d\n", -R + i / 2, 0, 0, R - ((i + 1) / 2));
    printf("wall %d %d %d %d\n", R - i / 2, 0, 0, R - ((i + 1) / 2));
  }

  forn(i, q1)
  {
    double A = (a[i] + a[i + 1]) / 2;
    printf("shoot %.0lf %.0lf\n", R * cos(A), R * sin(A));
  }
  puts("end");
  return 0;
}
