#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <map>
#include <cstdlib>
#include <cstdio>
#include <stack>
#include <deque>
#include <queue>
#include <cmath>

#define md 1000000000
#define N (500)
#define prev(x) ((x) - ((x) & (-x)))
#define next(x) ((x) + ((x) & (-x)))
#define ll long long
#define ull unsigned long long

#ifdef WIN32
    #define I64 I64d
#else
    #define I64 lld
#endif // WIN32

using namespace std;
vector<int> a;
int n;

class T {
    public:
        vector<pair<int, int> > Tree;
        void makeT(int n) {
            pair<int, int> temp;
            temp = make_pair(md, 0);
            Tree = vector<pair<int, int> > (4 * (n + 1), temp);
            Build(1, 1, n);
        }

        void Build(int id, int l, int r) {
            if (l > r) {
                return;
            }
            if (l == r) {
                Tree[id].first = a[l - 1];
                Tree[id].second = l;
                return;
            }
            Build(id + id, l, (l + r) / 2);
            Build(id + id + 1, (l + r) / 2 + 1, r);
            Tree[id].first = min(Tree[id + id].first, Tree[id + id + 1].first);
            if (Tree[id + id].first < Tree[id + id + 1].first) {
                Tree[id].second = Tree[id + id].second;
            } else {
                Tree[id].second = Tree[id + id + 1].second;
            }
        }

        pair<int, int> getmin(int id, int ql, int qr, int l, int r) {
            if (ql > r || qr < l) {
                return make_pair(md, -1);
            }
            if (ql <= l && qr >= r) {
                return make_pair(Tree[id].first, Tree[id].second);
            }
            pair<int, int> p1, p2;
            p1 = getmin(id + id, ql, qr, l, (l + r)/2);
            p2 = getmin(id + id + 1, ql, qr, (l + r) / 2 + 1, r);
            if (p1.first < p2.first) {
                return p1;
            } else {
                return p2;
            }
        }
};

T tree;
long long rec(int l, int r) {
    if (l > r) {
        return 0;
    }
    if (l == r) {
        return a[l - 1];
    }
    pair<int, int> p = tree.getmin(1, l, r, 1, n);
    return (p.second - l + 1) * (r - p.second + 1) * p.first + rec(l, p.second - 1) + rec(p.second + 1, r);
}


int main() {
    #ifdef DEBUG
        freopen("input.txt", "r", stdin);
        //freopen("output.txt", "w", stdout);
    #else
        //freopen("input.txt", "r", stdin);
        //freopen("output.txt", "w", stdout);
    #endif // DEBUG
    cin >> n;
    for (int i = 0; i < n; i++) {
        int x;
        cin >> x;
        a.push_back(x);
    }
    tree.makeT(n);
    cout << rec(1, n);


    return 0;
}
