#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <map>
#include <cstdlib>
#include <cstdio>
#include <stack>
#include <deque>
#include <queue>
#include <cmath>
#include <ctime>

#define md 1000000000
#define N (500)
#define prev(x) ((x) - ((x) & (-x)))
#define next(x) ((x) + ((x) & (-x)))
#define ll long long
#define ull unsigned long long

#ifdef WIN32
    #define I64 I64d
#else
    #define I64 lld
#endif // WIN32

using namespace std;
vector<long long> a;
long long n;
            pair<long long, long long> p1, p2;

class T {
    public:
        vector<pair<long long, long long> > Tree;
        void makeT(long long n) {
            pair<long long, long long> temp;
            temp = make_pair(md, 0);
            Tree = vector<pair<long long, long long> > (4 * (n + 1), temp);
            Build(1, 1, n);
        }

        void Build(long long id, long long l, long long r) {
            if (l > r) {
                return;
            }
            if (l == r) {
                Tree[id].first = a[l - 1];
                Tree[id].second = l;
                return;
            }
            Build(id + id, l, (l + r) / 2);
            Build(id + id + 1, (l + r) / 2 + 1, r);
            Tree[id].first = min(Tree[id + id].first, Tree[id + id + 1].first);
            if (Tree[id + id].first < Tree[id + id + 1].first) {
                Tree[id].second = Tree[id + id].second;
            } else {
                Tree[id].second = Tree[id + id + 1].second;
            }
        }

        pair<long long, long long> getmin(long long id, long long ql, long long qr, long long l, long long r) {
            if (ql > r || qr < l) {
                return make_pair(md, -1);
            }
            if (ql <= l && qr >= r) {
                return make_pair(Tree[id].first, Tree[id].second);
            }
            p1 = getmin(id + id, ql, qr, l, (l + r)/2);
            p2 = getmin(id + id + 1, ql, qr, (l + r) / 2 + 1, r);
            if (p1.first < p2.first) {
                return p1;
            } else {
                return p2;
            }
        }
};

T tree;
long long rec(long long l, long long r) {
    if (l > r) {
        return 0;
    }
    if (l == r) {
        return a[l - 1];
    }
    pair<long long, long long> p = tree.getmin(1, l, r, 1, n);
    return 1ll * (p.second - l + 1) * (r - p.second + 1) * p.first + 1ll * rec(l, p.second - 1) + 1ll * rec(p.second + 1, r);
}

long long BruteForce() {
    long long result = 0;
    for (long long i = 0; i < n; i++) {
        for (long long j = 0; j < n; j++) {
            long long minn = md;
            if (j >= i) {
                for (long long z = i; z <= j; z++) {
                    minn = min(minn, a[z]);
                }
            }
            if (minn != md) result += minn;
        }
    }
    return result;
}


int main() {
    #ifdef DEBUG
        freopen("input.txt", "r", stdin);
        //freopen("output.txt", "w", stdout);
    #else
        //freopen("input.txt", "r", stdin);
        //freopen("output.txt", "w", stdout);
    #endif // DEBUG
    srand(time(NULL));
    cin >> n;
    for (long long i = 0; i < n; i++) {
        long long x;
        cin >> x;
        //x = 1000000;
        //cout << x << " ";
        a.push_back(x);
    }

    tree.makeT(n);
    cout << rec(1, n);
    /*
    if (BruteForce() != rec(1, n)) {
        system("pause");
    }
    */

    return 0;
}
