#include <iostream>
#include <cstdio>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <vector>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <cstdlib>
#include <cassert>

using namespace std;
#define forn(i, n) for (int i = 0; i < n; ++i)
#define ALL(a) a.begin(), a.end()
#define X first
#define Y second
#define sz(a) ((int)a.size())
#define L(a) sz(a)
#define pb(a) push_back(a)
#define mp(a, b) make_pair(a, b)
#define ms(a) memset(a,0,sizeof(a))
#define ms1(a) memset(a,-1,sizeof(a))

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;

const double PI = 3.1415926535897932384626433832795;

struct seg {
	vector<int> a;
	vector<int> s;
	int query(int x) {
		int pos = upper_bound(ALL(s),x)-s.begin();
		return pos;
	}
};

seg build(const vector<int>& v) {
	seg res;
	res.a = v;
	res.s = v;
	sort(ALL(res.s));
	return res;
}

const int BL = 500;
const int MAGIC = 1500;
vector<seg> v;

void rebuild() {
	vector<int> tmp;
	forn(i, sz(v)) tmp.insert(tmp.end(), ALL(v[i].a));
	v.clear();
	for (int i = 0; i < sz(tmp); i += BL) {
		int fr = i;
		int to = min(sz(tmp), i+BL);
		v.pb(build(vector<int>(tmp.begin()+fr, tmp.begin()+to)));
	}
}

int split(int pos) {
	int L = 0;
	forn(i, sz(v)) {
		int len = sz(v[i].a);
		int R = L+len-1;
		if (pos >= L && pos <= R) {
			if (pos == L) return i;
			vector<int> v1 = vector<int>(v[i].a.begin(), v[i].a.begin()+(pos-L));
			seg s1 = build(v1);
			seg s2 = build(vector<int>(v[i].a.begin()+(pos-L), v[i].a.end()));
			v[i] = s2;
			v.insert(v.begin()+i,s1);
			return i+1;
		}
		L += len;
	}
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	/*freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);*/
#endif
	int n; scanf("%d", &n);
	vector<int> tmp(n);
	forn(i, n) scanf("%d", &tmp[i]);
	v.pb(build(tmp));
	rebuild();
	string qt;
	while(cin >> qt) {
		if (qt == "+") {
			int i, x; scanf("%d%d", &i, &x);
			int pos = split(i);
			v.insert(v.begin()+pos, build(vector<int>(1, x)));
		} else if (qt == "-") {
			int i; scanf("%d", &i);
			int pos = split(i);
			split(i+1);
			v.erase(v.begin()+pos);
		} else if (qt == "?") {
			int L, R, X; scanf("%d%d%d", &L, &R, &X);
			int l = split(L);
			int r = split(R+1);
			int ans = 0;
			for (int i = l; i < r; ++i) ans += v[i].query(X);
			printf("%d\n", ans);
		}
		if (sz(v) > MAGIC) rebuild();
	}
	return 0;
}
