#include <iostream>
#include <cstdio>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <vector>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <cstdlib>
#include <cassert>

using namespace std;
#define forn(i, n) for (int i = 0; i < n; ++i)
#define ALL(a) a.begin(), a.end()
#define X first
#define Y second
#define sz(a) ((int)a.size())
#define L(a) sz(a)
#define pb(a) push_back(a)
#define mp(a, b) make_pair(a, b)
#define ms(a) memset(a,0,sizeof(a))
#define ms1(a) memset(a,-1,sizeof(a))

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const double PI = 3.1415926535897932384626433832795;

const int cinf = 1000000010;

struct node {
	int l, r;
	int add;
	int min;
	ll cmin;
	node():l(-1),r(-1),add(0),min(cinf),cmin(0) {}
	node(int l, int r, int add, int min, ll cmin):l(l),r(r),add(add),min(min),cmin(cmin) {}
};

vector<node> t;
int X, Y;
int getnode() {
	t.pb(node());
	return sz(t)-1;
}

int getnode(int l, int r, int add, int min, ll cmin) {
	t.pb(node(l,r,add,min,cmin));
	return sz(t)-1;
}

int build(int L, int R) {
	return getnode(-1,-1,0,0,(R-L+1));
}

void push(int v) {
	if (t[v].add) {
		if (t[v].l != -1) t[t[v].l].add += t[v].add;
		if (t[v].r != -1) t[t[v].r].add += t[v].add;
		t[v].min += t[v].add;
		t[v].add = 0;
	}
}

void modify(int v, ll L, ll R, ll l, ll r, int add) {
	l = max(l, (ll)0);
	r = min(r, (ll)Y);
	if (L > r || l > R) return;
	if (l <= L && R <= r) t[v].add += add;
	else {
		ll m = (L+R)>>1;
		if (t[v].l == -1) t[v].l = getnode(-1,-1,0,0,(m-L+1));
		if (t[v].r == -1) t[v].r = getnode(-1,-1,0,0,(R-m));
		push(v);
		modify(t[v].l,L,m,l,r,add);
		modify(t[v].r,m+1,R,l,r,add);
		t[v].min = min(t[t[v].l].min, t[t[v].r].min);
		t[v].cmin = 0;
		push(t[v].l);
		push(t[v].r);
		if (t[v].min == t[t[v].l].min) t[v].cmin += t[t[v].l].cmin;
		if (t[v].min == t[t[v].r].min) t[v].cmin += t[t[v].r].cmin;
	}
}

pii query(int v, ll L, ll R, ll l, ll r) {
	l = max(l, 0LL);
	r = min(r, (ll)Y);
	if (L > r || l > R) return mp(cinf,0);
	if (l <= L && R <= r) return mp(t[v].min+t[v].add, t[v].cmin);
	ll m = (L+R)>>1;
	if (t[v].l == -1) t[v].l = getnode(-1,-1,0,0,(m-L+1));
	if (t[v].r == -1) t[v].r = getnode(-1,-1,0,0,(R-m));
	push(v);
	pii r1 = query(t[v].l, L,m,l,r);
	pii r2 = query(t[v].r, m+1,R,l,r);
	pii res;
	res.X = min(r1.X, r2.X);
	if (res.X == r1.X) res.Y += r1.Y;
	if (res.X == r2.X) res.Y += r2.Y;
	return res;
}





struct ev {
	ll pos;
	ll y;
	bool isbeg;
	ev() {}
	ev(ll pos, ll y, bool isbeg):pos(pos),y(y),isbeg(isbeg) {}
	bool operator<(const ev& o) const {
		return pos < o.pos;
	}
};

pll solve(const vector<pll>& v, ll d) {
	vector<ev> e;
	t.clear();
	int root = build(0, Y);
	e.pb(ev(0,0,1));
	e.pb(ev(X,0,0));
	e.pb(ev(0,Y,1));
	e.pb(ev(X,Y,0));
	e.pb(ev(d+1,0,1));
	e.pb(ev(d+1,0,0));
	e.pb(ev(X-d-1,0,1));
	e.pb(ev(X-d-1,0,0));
	forn(i, sz(v)) {
		e.pb(ev(v[i].X-d,v[i].Y,1));
		e.pb(ev(v[i].X+d+1,v[i].Y,0));
	}
	sort(ALL(e));
	for (int i = 0; i < sz(e); ) {
		int j = i;
		while (j < sz(e) && e[i].pos == e[j].pos) {
			ev cur = e[j];
			int add = -1;
			if (cur.isbeg) add = 1;
			modify(root, 0, Y, cur.y-d, cur.y+d, add);
			++j;
		}
		push(root);
		if (e[i].pos > d && e[i].pos < X-d) {
			if (query(root,0,Y,d+1,Y-d-1).X == 0) {
				ll l = d;
				ll r = Y-d;
				while (r-l>1) {
					ll m = (l+r)>>1;
					pll cv = query(root,0,Y,d+1,m);
					if (cv.X == 0) r = m;
					else l = m;
				}
				return mp(e[i].pos, r);
			}
		}
		i = j;
	}
	return mp(-1,-1);
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	/*freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);*/
#endif
	scanf("%d%d", &X, &Y); X *= 2, Y *= 2;
	int n; scanf("%d", &n);
	vector<pll> v(n);
	forn(i, n) {
		int cx, cy; scanf("%d%d", &cx, &cy);
		v[i] = mp(cx*2,cy*2);
	}
	solve(v, 1LL);
	ll l = 0;
	ll r = 3e9;
	while (r-l>1) {
		ll m = (l+r)>>1;
		pll res = solve(v, m);
		if (res.X < 0) r = m;
		else l = m;
	}
	pll ans = solve(v, l);
	cout << l+1 << "\n";
	ll rx = ans.X-l-1;
	ll ry = ans.Y-l-1;
	/*assert(rx%2==0);
	assert(ry%2==0);*/
	rx /= 2;
	ry /= 2;
	cout << rx << " " << ry << "\n";
	return 0;
}
