#include <iostream>
#include <cmath>
#include <string>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <fstream>
#include <cassert>
#include <map>
#include <set>
#include <vector>
#include <queue>
#include <stack>
#include <functional>
#include <numeric>
#include <ctime>
#include <cstdlib>
#include <sstream>

using namespace std;

#define f first
#define s second
#define mp make_pair
#define pb push_back
#define pii pair<int, int>
#define pll pair<long long, long long>
#define y1 stupid_y1
#define ll long long
#define vi vector<int>
#define forit(it, s) for(__typeof(s.begin()) it = s.begin(); it != s.end(); it++)
#define all(a) a.begin(), a.end()
#define sqr(x) ((x)*(x))
#define sz(a) (int)a.size()
#define file "a"

const int maxn = (int)1e5+11;
const int inf = int(1e9);
const int mod = inf + 7;
const double eps = 1e-9;
const double pi = acos(-1.0);

int n;
vi g[maxn], gr[maxn];
int sz = 0, len = 300;
int a[maxn];

void build() {
	sz = 0;
	for(int i = 0; i < n; i++) {
		g[sz].pb(a[i]);
		gr[sz].pb(a[i]);
		if(sz(g[sz]) == len) sz++;
	}
	if(!g[sz].empty()) sz++;
	for(int i = 0; i < sz; i++) sort(all(gr[i]));
}

void cpy() {
	n = 0;
	for(int i = 0; i < sz; i++) {
		forit(it, g[i]) a[n++] = *it;
		g[i].clear();
		gr[i].clear();
	}
}

void rebuild() {
	cpy();
	build();
}

void print() {
	for(int i = 0; i < sz; i++) {
		cout << i << ": ";
		forit(it, g[i]) cout << *it << " ";
		cout << endl << "   ";
		forit(it, gr[i]) cout << *it << " ";
		cout << endl;
	}
}

int getBlockNum(int ind) {
	for(int i = 0; i < sz; i++) {
		if(ind < sz(g[i])) return i;
		ind -= sz(g[i]);
	}
	return sz-1;
}

int getIndex(int ind) {
	for(int i = 0; i < sz; i++) {
		if(ind < sz(g[i])) return ind;
		ind -= sz(g[i]);
	}
	return sz(g[sz-1]);
}

void insert(vi &v, int ind, int val) {
	vi temp;
	for(int i = 0; i < ind; i++) temp.pb(v[i]);
	temp.pb(val);
	for(int i = ind; i < sz(v); i++) temp.pb(v[i]);
	v = temp;
}

void insert(int ind, int val) {
	int b = getBlockNum(ind);
	int new_ind = getIndex(ind);
	insert(g[b], new_ind, val);
	if(val >= gr[b].back()) gr[b].pb(val);
	else {
		if(gr[b][0] >= val) {
			insert(gr[b], 0, val);
		} else {
			int j = 0;
			while(gr[b][j] < val) j++;
			insert(gr[b], j, val);
		}
    }
}

void erase(vi &v, int ind) {
	vi temp;
	for(int i = 0; i < ind; i++) temp.pb(v[i]);
	for(int i = ind+1; i < sz(v); i++) temp.pb(v[i]);
	v = temp;
}

void erase(int ind) {
	int b = getBlockNum(ind);
	int new_ind = getIndex(ind);
	int val = g[b][new_ind];
	erase(g[b], new_ind);
	int j = 0;
	while(gr[b][j] != val) j++;
	erase(gr[b], j);
}

int calcInBlock(int b, int val) {
	vi &v = gr[b];
	int j = upper_bound(all(v), val) - v.begin();
	return max(j, 0);
}

int calc(int l, int r, int val) {
	int bl = getBlockNum(l);
	int br = getBlockNum(r);
	int indl = getIndex(l);
	int indr = getIndex(r);
	int ans = 0;

	for(int i = bl+1; i < br; i++) ans += calcInBlock(i, val);

	if(bl != br) {
		for(int i = indl; i < sz(gr[bl]); i++) ans += g[bl][i] <= val;
		for(int i = 0; i <= indr; i++) ans += g[br][i] <= val;
	} else {
		for(int i = indl; i <= indr; i++) ans += g[bl][i] <= val;
	}

	return ans;
}

int main () {

	#ifdef LOCAL
	freopen(file".in", "r", stdin);
	freopen(file".out", "w", stdout);
	#endif

	scanf("%d", &n);
	for(int i = 0; i < n; i++) scanf("%d", a + i);

	build();

	char tip;

	while(cin >> tip) {
		if(tip == '+') {

			int ind, val;

			scanf("%d%d", &ind, &val);

			insert(ind, val);

		} else if(tip == '-') {

			int ind;

			scanf("%d", &ind);

			erase(ind);


		} else {

			int l, r, x;

			scanf("%d%d%d", &l, &r, &x);

			printf("%d\n", calc(l, r, x));

		}
	}

	#ifdef LOCAL
	cerr << (double)clock() * 1.0 / CLOCKS_PER_SEC << endl;
	#endif

	return 0;
}














