#include <cstdio>
#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <map>
#include <cstring>
#include <string>
#include <set>
#include <iomanip>
using namespace std;
typedef pair <int, int> pii;
#define fname "kthstat."
#define pb push_back
#define ppb pop_back
#define F first
#define S second
#define mp make_pair
#define forit(it, s) for(__typeof(s.begin()) it = s.begin(); it != s.end(); it++)
#define all(s) s.begin(),s.end()
const int maxn = (int)2e5 + 10;
const int inf = (1 << 30) - 1;
const int magic = (int)1e5 + 10;
const int K = 500;

vector <int> tmp;

struct block {
	int sz;
	vector <int> v, vs;
	block *next;
	block() {v.clear(); vs.clear(); sz = 0; next = NULL; }
	void insert(int pos, int x) {
		tmp.clear();
		for (int i = 0; i < pos; i++)  tmp.pb(v[i]);
		tmp.pb(x);
		for (int i = pos; i < sz; i++) tmp.pb(v[i]);
		sz++; 
		v.pb(0); vs.pb(0);
		for (int i = 0; i < sz; i++) vs[i] = v[i] = tmp[i];
		sort(all(vs));
	}
	void erase(int pos) {
		tmp.clear();
		for (int i = 0; i < pos-1; i++)  tmp.pb(v[i]);
		for (int i = pos; i < sz; i++) tmp.pb(v[i]);
		sz--; 
		v.ppb(); vs.ppb();
		for (int i = 0; i < sz; i++) vs[i] = v[i] = tmp[i];
		sort(all(vs));
	}
	int get(int bl, int br, int L, int R, int x) {
		if (L <= bl && br <= R) 
			return upper_bound(vs.begin(), vs.end(), x) - vs.begin();
		int cnt = 0;
		for (int i = max(bl, L); i <= min(br, R); i++)
			if (v[i - bl] < x) ++cnt;
		return cnt;
	}

	void show() {
		for (int i = 0; i < sz; i++) 
			cout << v[i] << " ";
	}
} *head;


void split(block *cur) {
	block *b = new block();
	int mid = cur->sz / 2;
	for (int i = mid; i < cur->sz; i++) {
		b->v.pb(cur->v[i]);
		b->vs.pb(cur->v[i]);
	}
	for (int i = mid; i < cur->sz; i++) {
		cur->v.ppb();
		cur->vs.ppb();
	}
	for (int i = 0; i < mid; i++) 
		cur->vs[i] = cur->v[i];
	sort(all(b->vs));
	sort(all(cur->vs));

	cur->sz = cur->v.size();
	b->sz = b->v.size();

	b->next = cur->next;
	cur->next = b;
}

void add(int pos, int x) {
	block* cur = head;
	while (cur->sz < pos) {
		pos -= cur->sz;
		cur = cur->next;
	}
	cur->insert(pos, x);
	if (cur->sz >= K + K) 
		split(cur);
}

void erase(int pos) {
	block *cur = head;
	while (cur->sz < pos) {
		pos -= cur->sz;
		cur = cur->next;
	}
	cur->erase(pos);
//	if (cur->sz < K && cur->next != NULL) 
//		mergeBlocks(cur, cur->next);
}

int get(int l, int r, int x) {
	int cnt = 1, ans = 0;
	block *cur = head;
	while (cur != NULL) {
		ans += cur->get(cnt, cnt + cur->sz - 1, l, r, x);
		cnt += cur->sz;
		cur = cur->next;
	}
	return ans;
}


int n, a[maxn];
char ch;

void show() {
	block *cur = head;
	
	while (cur != NULL) {
		cout << "[ ";
		cur->show();
		cout << "]\t";
		cur = cur->next;
	}

}

int main()
{
	freopen(fname"in", "r", stdin);
	freopen(fname"out", "w", stdout);

	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n;

	head = new block();
	for (int i = 1; i <= n; ++i) { 
		cin >> a[i];
		add(i - 1, a[i]);
	}
//	show();

	int pos, x, l, r;
	while (cin >> ch)
	{
		
		if (ch == '-') {
			cin >> pos;
			erase(pos);
		}
		if (ch == '+') {
			cin >> pos >> x;
			add(pos, x);
		}
		if (ch == '?') {
			cin >> l >> r >> x;
			cout << get(l, r, x + 1) << "\n";
		}
	}


	return 0;
}
