#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define sz(x) ((int) (x).size())
#define pb push_back
#define mp make_pair
#define fi first
#define se second

#define NAME "test"

const int maxn = 220000;

struct event
{
	int t, x, y;
	
	event() {}
	event(int nt, int nx, int ny): t(nt), x(nx), y(ny) {}
	
	bool operator < (const event &e) const
	{
		if (x != e.x) return x < e.x;
		if (t != e.t) return t > e.t;
		return y < e.y;
	}
};

int n, x, y;
pair<int, int> data[maxn];
event evs[2 * maxn + 1];
int esz = 0;
multiset<int> brd;

void relax(int &x, int &y, int a, int b)
{
	//cerr << a << " " << b << endl;
	if ((ll) x * x + (ll) y * y < (ll) a * a + (ll) b * b )
		return;
	if ((ll) x * x + (ll) y * y > (ll) a * a + (ll) b * b)
	{
		x = a;
		y = b;
		return;
	}
	if (a < x || (a == x && b < y))
	{
		x = a;
		y = b;
	}
}

bool go(int d, int &ansx, int &ansy, bool fl)
{
	const int inf = 1e9 + 100500;
	ansx = inf;
	ansy = inf;
	
	esz = 0;
	for (int i = 0; i < n; ++i)
	{
		if (data[i].fi == 0 || data[i].fi == x || data[i].se == 0 || data[i].se == y)
			continue;
		evs[esz++] = event(0, data[i].fi, data[i].se);

		if (data[i].fi + d <= x)
			evs[esz++] = event(1, data[i].fi + d, data[i].se);
	}
	evs[esz++] = event(0, x + 1, 1);
	sort(evs, evs + esz);
	brd.clear();
	brd.insert(0);
	brd.insert(y);
	bool first = true, found = false;
	for (int i = 0; i < esz; ++i)
	{
		if (evs[i].x >= d && first)
		{
			//cerr << "LAL" << endl;
			first = false;
			for (auto it = brd.begin();; ++it)
			{
				if (it == --brd.end()) break;
				auto jt = it;
				++jt;
				//cerr << "AAA = " << *it << " " << *jt << endl;
				if (*jt - *it >= d)
				{
					if (fl) return true;
					relax(ansx, ansy, 0, *it);
					found = true;
				}
			}
		}
		if (evs[i].t == 0)
			brd.insert(evs[i].y);
		else
		{
			auto it = brd.lower_bound(evs[i].y);
			auto jt = it;
			assert(it != brd.begin());
			
			--jt;
			++it;
			//cerr << "BBB at " << evs[i].x - d << " = " << *it << " " << *jt << endl;
			if (*it - *jt >= d)
			{
				if (fl) return true;
				found = true;
				relax(ansx, ansy, evs[i].x - d, *jt);
			}
			brd.erase(--it);
		}
	}
	return found;
}

void dummy(int q, int w, int e)
{
	vector <pair <int, int> > ans;
	int sz = -1;
	for (int s = min(x, y); s > 0; --s)
	{
		sz = s;
		for (int i = 0; i + s <= x; ++i)
			for (int j = 0; j + s <= y; ++j)
			{
				bool ok = true;
				for (int k = 0; k < n; ++k)
				{
					if (data[k].fi > i && data[k].fi < i + s && data[k].se > j && data[k].se < j + s)
						ok = false;
				}
				if (ok)
					ans.pb(mp(i, j));
			}
		if (!ans.empty())
			break;
	}
	cerr << sz << '\n';
	pair <ld, pair <int, int> > best = mp(1e18, mp(-1, -1));
	for (int i = 0; i < sz(ans); ++i)
	{
		best = min(best, mp(hypotl(ans[i].fi, ans[i].se), mp(ans[i].fi, ans[i].se)));
	}
	cerr << best.se.fi << ' ' << best.se.se << '\n';
	cerr << '\n';
	assert(sz == q && best.se.fi == w && best.se.se == e);
}

void gen(int x, int y, int k)
{
	FILE *f = fopen(NAME ".in", "w");
	fprintf(f, "%d %d\n%d\n", x, y, k);
	for (int i = 0; i < k; ++i)
		fprintf(f, "%d %d\n", rand() % (x + 1), rand() % (y + 1));
	fclose(f);
}

#ifdef LOCAL
void initrand()
{
	ll seed;
	asm("rdtsc":"=A"(seed));
	srand(seed);
}
#endif

int main()
{
	#ifdef LOCAL
	initrand();
	gen(100, 100, 1000);
	assert(freopen(NAME ".in", "r", stdin));
	#endif // LOCAL
	scanf("%d%d%d", &x, &y, &n);
	for (int i = 0; i < n; ++i)
		scanf("%d%d", &data[i].fi, &data[i].se);
	int l = 1, r = min(x, y);
	while (l < r)
	{
		int m = (l + r) / 2 + 1, xx, yy;
		if (go(m, xx, yy, true))
			l = m;
		else
			r = m - 1;
	}
	
	printf("%d\n", l);
	int xx, yy;
	go(l, xx, yy, false);
	printf("%d %d\n", xx, yy);
	dummy(l, xx, yy);
	#ifdef LOCAL
	cerr << "Time: " << double(clock()) / CLOCKS_PER_SEC << "\n";
	#endif // LOCAL
	return 0;
}
