#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>

using namespace std;

const int maxn = 2 * 1e5;
const int shift = 350;

int n;
vector<int> a;

class seg{
public:
    int l, r;
    vector<int> m;
    vector<int> s;
    seg() {}
    seg(int _l, int _r) {
        l = _l;
        r = _r;
        for (int i = l; i < r; ++i)
            m.push_back(a[i]);
        s = m;
        sort(s.begin(), s.end());
    }
    int get(int x) {
        return int(lower_bound(s.begin(), s.end(), x) - s.begin());
    }
};

vector<seg *> T;

int split(int pos) {
    int i;
    for (i = 0; i < T.size(); ++i)
        if (T[i]->l <= pos && T[i]->r > pos)
            break;

    cerr << i << " " << T.size() << " " << T[0]->l << " " << T[0]->r << " " << pos << endl;

    int l = T[i]->l;
    int r = T[i]->r;

    T[i] = new seg(l, pos);
    T.insert(T.begin() + i, new seg(pos, r));

    return i + 1;
}

void insert(int pos, int x) {
    a[n++] = x;
    int j = split(pos);
    T.insert(T.begin() + j, new seg(n, n + 1));
}

void erase(int pos) {
    cerr << "Here" << endl;
    int j = split(pos);
    split(pos + 1);
    cerr << "Here" << endl;
    T.erase(T.begin() + j);
}

int getK(int l, int r, int x) {
    l = split(l), r = split(r);
    int res = 0;
    while (l <= r)
        res += T[l++]->get(x);
    return res;
}

int main()
{
    cin >> n;
    a.resize(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i];

    int cur = 0;
    while (cur < n) {
        T.push_back(new seg(cur, cur + shift));
        cur += shift;
    }

    char c;
    while (cin >> c) {
        cerr << "_____________________________\n";
        for (int i = 0; i < T.size(); ++i)
            cerr << T[i]->l << " " << T[i]->r << endl;
        cerr << "_____________________________\n";
        if (c == '+') {
            int pos, x;
            cin >> pos >> x;
            insert(pos, x);
        }
        if (c == '-') {
            int x;
            cin >> x;
            erase(x);
        }
        if (c == '?') {
            int l, r, x;
            cin >> l >> r >> x;
            ++r;
            cout << getK(l, r, x) << endl;
        }
        cerr << "_____________________________\n";
        for (int i = 0; i < T.size(); ++i)
            cerr << T[i]->l << " " << T[i]->r << endl;
        cerr << "_____________________________\n";
    }

    return 0;
}
