#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cassert>

#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <deque>
#include <queue>
#include <stack>
#include <algorithm>


#define forn(i, n) for(int i = 0; i < int(n); i++)
#define mp make_pair
#define pb push_back
#define foreach(it, v) for(__typeof(v.begin()) it = v.begin(); it != v.end(); ++it)

using namespace std;

typedef long long ll;

const int MAXN = 100010;

int n;
int arr[MAXN];
typedef pair < int, int > pair_t;
pair_t segTree[4 * MAXN];

void build(int v, int l, int r) {
	if(l == r) {
		segTree[v] = mp(arr[l], l);
	} else {
		int m = (l + r) >> 1;
		build(2 * v, l, m); build(2 * v + 1, m + 1, r);
		segTree[v] = min(segTree[2 * v], segTree[2 * v + 1]);
	}
}

pair_t getMin(int v, int l, int r, int tl, int tr) {
	if(l == tl && r == tr) return segTree[v];
	int m = (l + r) >> 1;
	pair_t result = make_pair(1e9, -1);
	if(tl <= m) result = getMin(2 * v, l, m, tl, min(tr, m));
	if(tr > m) result = min(result, getMin(2 * v + 1, m + 1, r, max(m + 1, tl), tr));
	return result;
}

ll rec(int l, int r) {
	ll result = 0;
	pair_t m = getMin(1, 0, n - 1, l, r);
//	cout << l << " " << r << " " << m.second << endl;
	ll left = m.second - l + 1;
	ll right = r - m.second + 1;
	result += left * right * m.first;
	if(l < m.second) result += rec(l, m.second - 1);
	if(m.second < r) result += rec(m.second + 1, r);
	return result;
}

int main() {
	scanf("%d", &n);
	for(int i = 0; i < n; i++) scanf("%d", &arr[i]);
	build(1, 0, n - 1);
	ll result = rec(0, n - 1);
	printf("%lld\n", result);
	return 0;
}