#include <cstdio>
#include <algorithm>
#include <iostream>
#include <cmath>
using namespace std;

const int kMaxN = 1e5 + 10;
const int kMaxLog = 20;

int n;
int a[kMaxN];
int table[kMaxLog][kMaxN];
int prelog[kMaxN];

void BuidlPrelog()
{
    prelog[1] = 0;
    for (int i = 1; i < kMaxN; ++i) {
        prelog[i] = prelog[i - 1];
        if ((1 << (prelog[i] + 1)) <= i) {
            ++prelog[i];
        }
    }
}

void BuildTable()
{
    for (int i = 0; i < n; ++i) {
        table[0][i] = a[i];
    }
    for (int lvl = 1; lvl < kMaxLog; ++lvl) {
        for (int i = 0; i < n; ++i) {
            table[lvl][i] = table[lvl - 1][i];
            if (i + (1 << (lvl - 1)) < n) {
                table[lvl][i] = min(table[lvl][i], table[lvl - 1][i + (1 << (lvl - 1))]);
            }
        }
    }
}

int GetInTable(int l, int r)
{
    int len = r - l + 1;
    int cur_log = prelog[len];

    return min(table[cur_log][l], table[cur_log][r - (1 << cur_log) + 1]);
}

int main()
{
    scanf("%d", &n);
    for (int i = 0; i < n; ++i) {
        scanf("%d", a + i);
    }

    BuidlPrelog();
    BuildTable();

    long long answer = 0;
    for (int pos = 0; pos < n; ++pos) {
        int left = pos;
        int bleft = 0;
        int bright = pos - 1;
        while (bleft <= bright) {
            int bmiddle = (bleft + bright) >> 1;
            if (GetInTable(bmiddle, pos - 1) > a[pos]) {
                left = bmiddle;
                bright = bmiddle - 1;
            } else {
                bleft = bmiddle + 1;
            }
        }
        int right = pos;
        bleft = pos + 1;
        bright = n - 1;
        while (bleft <= bright) {
            int bmiddle = (bleft + bright) >> 1;
            if (GetInTable(pos + 1, bmiddle) >= a[pos]) {
                right = bmiddle;
                bleft = bmiddle + 1;
            } else {
                bright = bmiddle - 1;
            }
        }

        answer += 1LL * a[pos] * (pos - left + 1) * (right - pos + 1);
    }

    cout << answer << endl;


    return 0;
}
