#include<iostream>
#include<stdio.h>
#include<queue>
using namespace std;
typedef long long lint;
const int inf = 1000000000;
const int SIZE = 200000;
int a[SIZE];
lint answer;


int Rand()
{
	return (rand()>>15)^rand();
}


struct type
{
	int x,y;
	int minValue,value;
	type *l,*r;
};

int minValue(type *T)
{
	if(T) return T->minValue;
	return inf;
}

void fix(type *&T)
{
	if(!T) return;
	T->minValue = T->value;
	T->minValue = min(T->minValue,minValue(T->l));
	T->minValue = min(T->minValue,minValue(T->r));
}




type* merge(type *l,type *r)
{
	if(!l||!r) return l?l:r;
	if(l->y > r->y)
	{
		l->r = merge(l->r,r);
		fix(l);
		return l;
	}
	r->l = merge(l,r->l);
	fix(r);
	return r;
}

void split(type *T,int x,type *&l,type *&r)
{
	if(!T) { l=r=NULL; return; }
	if(T->x==x)
	{
		r=T->r;
		l=T;	l->r=NULL;
		fix(l);	fix(r);
		return;
	}
	type *ll,*rr;
		
	if(T->x<x)
	{
		split(T->r,x,ll,rr);
		l=T; T->r = ll;
		r=rr;
		
		fix(l);	fix(r);
		return;
	}
	split(T->l,x,ll,rr);
	l=ll;
	r=T;	r->l=rr;
	fix(l);	fix(r);
}

type* add(type *T,int index,int value)
{
	type *p = (type*)malloc(sizeof(type));
	p->l=p->r=NULL;
	p->value=value;
	p->x=index;
	p->y=Rand();
	fix(p);
	type *l,*r;
	split(T,index,l,r);
	return merge(l,merge(p,r));
}

int indexWithMin(type *T)
{
	if(T->minValue==T->value) return T->x;
	if(minValue(T->l)==T->minValue) return  indexWithMin(T->l);
	return indexWithMin(T->r);
}

type* remove(type *T,int x)
{
	if(T->x==x)
	{
		return merge(T->l,T->r);
	}
	if(T->x < x)
	{
		T->r = remove(T->r,x);
		return T;
	}
	T->l = remove(T->l,x);
	return T;
}






void solve(type *T,int l,int r)
{
	if(r<l) return;
	int minV = T->minValue;
	int index = indexWithMin(T);


	lint L=index-l+1;
	lint R=r-index+1;
	answer+=(L*R)*minV;
	T = remove(T,index);
	type *ll,*rr;
	split(T,index,ll,rr);
	solve(ll,l,index-1);
	solve(rr,index+1,r);
}


	
int main()
{
	int N,i;
	scanf("%d",&N);
	type *T=NULL;
	for(i=0;i<N;i++)
	{
		scanf("%d",&a[i]);
		T = add(T,i,a[i]);
	}
	solve(T,0,N-1);
	cout << answer;
	return 0;
}