#include <cstdio>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <memory.h>
#include <queue>
#include <deque>
#include <stack>
#include <list>
#include <map>
#include <set>
#include <functional>
#include <cstring>
#include <ctime>

using namespace std;

#define all(a) a.begin(), a.end()
#define mp make_pair

typedef long long li;
typedef long double ld;
typedef pair<int, int> pi;
typedef vector<int> vi;

#define FILENAME ""

void solve();
int main() {
#ifdef YA
	string s = FILENAME;
	//assert(!s.empty());
	clock_t start = clock();
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen(FILENAME ".in", "r", stdin);
	//freopen(FILENAME ".out", "w", stdout);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	cout.sync_with_stdio(0);
	cin.tie(0);
	cout.precision(15);
	cout << fixed;

	int t = 1;
	//cin >> t;
	while(t--) {
		solve();
	}
#ifdef YA
	cout << "\n\n" << (clock() - start) / 1.0 / CLOCKS_PER_SEC << "\n\n";
#endif
	return 0;
}


//#define int li

const int maxn = 200000;

int n = 0;

int curN = 0;

struct Segment {
	vector <int> sorted;
	vector <int> init;

	Segment() {}
	Segment(const vector <int>& a)/*:next(nullptr)*/ {
		sorted = a;
		sort(sorted.begin(), sorted.end());
		init = a;
	}
	int get(int x) {
		/*if (sorted[0] > x) {
			return 0;
		}*/
		return upper_bound(sorted.begin(), sorted.end(), x) - sorted.begin();
	}
	//Segment* next;
};

vector <Segment*> T;

void split(int id, int pos) {	
	vector <int> b[2];
	Segment* a = T[id];

	b[0] = vector <int>(a->init.begin(), a->init.begin() + pos);
	b[1] = vector <int>(a->init.begin() + pos, a->init.end());
	Segment* s0 = new Segment(b[0]);
	Segment* s1 = new Segment(b[1]);

	T[id] = s0;
	T.insert(T.begin() + id + 1, s1);
}

int split(int pos) {
	for (int i = 0; i < T.size(); ++i) {
		if (pos < T[i]->init.size()) {
			if (pos == 0) {
				return i;
			}
			split(i, pos);
			return i + 1;
		}
		else {
			pos -= T[i]->init.size();
		}
	}
	return T.size();
}

void insert(int i, int x) {
	int j = split(i);
	T.insert(T.begin() + j, new Segment(vector <int> (1, x)));
}

void erase(int i) {
	int j = split(i);
	split(i + 1);
	T.erase(T.begin() + j);
}

void build(const vector <int>& a) {
	vector <int> b;
	
	int sizeP = int(sqrt(curN * 1.0) + 2.0);

	T.clear();

	for (int i = 0; i < a.size(); ++i) {
		if (b.size() >= sizeP) {
			T.push_back(new Segment(b));
			b.clear();
		}
		b.push_back(a[i]);
	}
	if (b.size()) {
		T.push_back(new Segment(b));
	}
}

void rebuild() {
	int sizeP = int(sqrt(curN * 1.0) + 2.0);

	if (T.size() < 3 * sizeP) {
		return ;
	}

	vector <int> a;
	for (int i = 0; i < T.size(); ++i) {
		a.insert(a.end(), T[i]->init.begin(), T[i]->init.end());
	}
	T.clear();

	build(a);
}

void solve() {
	int n;
	cin >> n;

	vector <int> a;
	a.resize(n);

	curN = n;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	build(a);

	char c;
	while (cin >> c) {
		if (c == '+') {
			int i, x;
			cin >> i >> x;
			//--i;
			insert(i, x);
			++curN;
			rebuild();
		}

		if (c == '-') {
			int i;
			cin >> i;
			//--i;
			erase(i);
			--curN;
			
			rebuild();
		}
		if (c == '?') {
			int l,  r,  x;
			cin >> l >> r >> x;
			//--l;
			++r;

			l = split(l);
			r = split(r);
			int ans = 0;
			while (l < r) {
				ans += T[l++]->get(x);
			}

			cout << ans << "\n";

			
			rebuild();
		}
	}
}