#include <cstdio>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <memory.h>
#include <queue>
#include <deque>
#include <stack>
#include <list>
#include <map>
#include <set>
#include <functional>
#include <cstring>
#include <ctime>

using namespace std;

#define all(a) a.begin(), a.end()
#define mp make_pair

typedef long long li;
typedef long double ld;
typedef pair<int, int> pi;
typedef vector<int> vi;

#define FILENAME ""

void solve();
int main() {
#ifdef YA
	string s = FILENAME;
	//assert(!s.empty());
	clock_t start = clock();
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen(FILENAME ".in", "r", stdin);
	//freopen(FILENAME ".out", "w", stdout);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	cout.sync_with_stdio(0);
	cin.tie(0);
	cout.precision(15);
	cout << fixed;

	int t = 1;
	//cin >> t;
	while(t--) {
		solve();
	}
#ifdef YA
	cout << "\n\n" << (clock() - start) / 1.0 / CLOCKS_PER_SEC << "\n\n";
#endif
	return 0;
}


//#define int li

int maxW, maxH;

int n;

vector<pair<int, int>> points;

vector<int> yes;

pair<int, int> RES;

struct eve {
	int x;
	int h;
	bool added;
	eve() {}
	eve(int x, int h, bool added): x(x), h(h), added(added) {}
	bool operator < (const eve& other) const {
		return x < other.x;
	}
};

const int INF = 2e9;

struct vertex {
	int leftPoint, rightPoint;
	pair<int, int> bestSegment;
	vertex() {
		leftPoint = INF;
		rightPoint = -1;
		bestSegment = mp(0, 0);
	}
	vertex(int leftPoint, int rightPoint, pair<int, int> bestSegment):leftPoint(leftPoint), rightPoint(rightPoint), bestSegment(bestSegment) {}
};

int getLength(pair<int, int> cur) {
	if (cur.first == INF || cur.second == INF || cur.first == -1 || cur.second == -1)
		return -INF;
	if (cur.first > cur.second)
		return -INF;
	return yes[cur.second] - yes[cur.first];
}

vertex merge(const vertex& l, const vertex& r) {
	vertex res;
	if (l.leftPoint == INF)
		return r;
	if (r.leftPoint == INF)
		return l;
	res.leftPoint = l.leftPoint;
	res.rightPoint = r.rightPoint;
	res.bestSegment = l.bestSegment;
	if (getLength(res.bestSegment) < getLength(mp(l.rightPoint, r.leftPoint)))
		res.bestSegment = mp(l.rightPoint, r.leftPoint);
	if (getLength(res.bestSegment) < getLength(r.bestSegment))
		res.bestSegment = r.bestSegment;
	return res;
}

const int shift = 1 << 18;

vertex tree[2 * shift + 5];

int values[shift];

void insert(int v) {
	++values[v];
	if (values[v] == 1) { 
		v += shift;
		tree[v] = vertex(v - shift, v - shift, mp(0, 0));
		v /= 2;
		while(v > 0) {
			tree[v] = merge(tree[2 * v], tree[2 * v + 1]);
			v /= 2;
		}
	}
}

void erase(int v) {
	--values[v];
	if (values[v] == 0) { 
		v += shift;
		tree[v] = vertex();
		v /= 2;
		while(v > 0) {
			tree[v] = merge(tree[2 * v], tree[2 * v + 1]);
			v /= 2;
		}
	}
}

vertex query() {
	return tree[1];
}

li getDist(pair<int, int> now) {
	return now.first * 1LL * now.first + now.second * 1LL * now.second;
}

void updateRes(pair<int, int> now) {
	if (getDist(now) < getDist(RES) || getDist(now) == getDist(RES) && now.first < RES.first)
		RES = now;
}

bool check(int len) {
	vector<eve> events;
	events.push_back(eve(0, 0, true));
	events.push_back(eve(0, yes.size() - 1, true));
	for (int i = 0; i < n; ++i) {
		events.push_back(eve(max(points[i].first - len + 1, 0), points[i].second, true));
		events.push_back(eve(points[i].first, points[i].second, false));
	}
	//events.push_back(eve(maxW + 1, 0, false));
	//events.push_back(eve(maxW + 1, yes.size() - 1, false));

	bool f = false;

	sort(all(events));
	for (int i = 0; i < events.size(); ) {
		int start = i;
		while (i < events.size() && events[i].x == events[start].x)
			++i;

		for (int j = start; j < i; ++j) {
			eve cur = events[j];
			if (cur.added)
				insert(cur.h);
			else
				erase(cur.h);
		}

		if (events[start].x <= maxW - len) {
			vertex res = query();
			int curLength = getLength(res.bestSegment);
			curLength = min(curLength, maxW - events[start].x);
			if (curLength >= len) {
				updateRes(mp(events[start].x, yes[res.bestSegment.first]));
				f = true;
			}
		}
	}
	return f;
}

void solve() {
	cin >> maxW >> maxH;
	cin >> n;
	points.resize(n);
	for (int i = 0; i < n; ++i) {
		cin >> points[i].first >> points[i].second;
		yes.push_back(points[i].second);
	}
	yes.push_back(0);
	yes.push_back(maxH);

	sort(all(yes));
	yes.erase(unique(all(yes)), yes.end());

	for (int i = 0; i < n; ++i) {
		points[i].second = lower_bound(all(yes), points[i].second) - yes.begin();
	}

	int L = 0, R = min(maxW, maxH) + 1;

	while (L + 1 < R) {
		int M = (L + R) / 2;

		if (check(M))
			L = M;
		else
			R = M;
	}

	cout << L << "\n";
	RES = mp(INF, INF);
	check(L);

	cout << RES.first << ' ' << RES.second << "\n";

}