#include <iostream>
#include <algorithm>
#include <string>
#include <cstring>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <cstdio>
#include <stack>

using namespace std;

const int MAX_N = 100005;
const int INF = 1000000000;

struct SegmentTree {
    int offset;
    vector< pair< int, int > > v;

    void initialize(int n, int a[]) {
        for (offset = 1; offset < n; offset <<= 1)
            ;

        v.resize(2 * offset, make_pair(INF, 0));

        for (int i = 0; i < n; i++) {
            v[offset + i] = make_pair(a[i], i);
        }

        for (int i = offset - 1; i > 0; i--) {
            v[i] = min(v[i * 2], v[i * 2 + 1]);
        }
    }

    pair< int, int > query(int x, int lo, int hi, int a, int b) {
        if (lo >= b || hi <= a) {
            return make_pair(INF, 0);
        } else if (lo >= a && hi <= b) {
            return v[x];
        }

        return min(query(x * 2, lo, (lo + hi) / 2, a, b), query(x * 2 + 1, (lo + hi) / 2, hi, a, b));
    }

    pair< int, int > query(int a, int b) {
        return query(1, 0, offset, a, b + 1);
    }
};

int n, a[MAX_N];
SegmentTree tree;

long long solve(int x, int y) {
    if (x > y) {
        return 0;
    } else if (x == y) {
        return a[x];
    }

    int d = tree.query(x, y).second;
    long long ans = (long long)(y - d + 1) * (long long)(d - x + 1) * a[d];
    ans += solve(x, d - 1) + solve(d + 1, y);

    return ans;
}

int main() {
    freopen("minsum.in", "r", stdin);
    freopen("minsum.out", "w", stdout);

    scanf("%d", &n);

    for (int i = 0; i < n; i++) {
        scanf("%d", &a[i]);
    }

    tree.initialize(n, a);

    printf("%lld\n", solve(0, n - 1));

    return 0;
}
