#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int sqrtn = 316;

struct segment
{
	vector<int> a, good;
	void init(vector<int> vec)
	{
		a = vec;
		sort(vec.begin(), vec.end());
		good = vec;
	}
	
	void ins(int x, int add)
	{
		a.insert(a.begin() + x, add);
		int t = upper_bound(good.begin(), good.end(), add) - good.begin();
		good.insert(good.begin() + t, add);
		
	}
	
	void del(int x)
	{
		int add = a[x];
		a.erase(a.begin() + x);
		good.erase(lower_bound(good.begin(), good.end(), add));
	}
	
	int query(int x)
	{
		return upper_bound(good.begin(), good.end(), x) - good.begin();
	}
	
	vector<int> split()
	{
		vector<int> res;
		for(int i = a.size() / 2; i < a.size(); i++) {
			res.push_back(a[i]);
		}
		a.resize(a.size() / 2);
		good = a;
		sort(good.begin(), good.end());
		return res;
	}
	
};

segment *segs[1000];

int main()
{
	ios_base::sync_with_stdio(false);
	int n;
	cin >> n;
	vector<int> cur;
	int x = 0;
	int k = 0;
	for(int i = 0; i < n; i++)
	{
		int x;
		cin >> x;
		cur.push_back(x);
		if (cur.size() == sqrtn)
		{
			segs[k] = new segment;
			segs[k++]->init(cur);
			cur.clear();
		}
	}
	if (cur.size() > 0) {
		segs[k] = new segment;
			segs[k++]->init(cur);
			cur.clear();
	}
	char c;
	while(cin >> c)
	{
		if (c == '-')
		{
			int x;
			cin >> x;
			int s = 0, lasts = 0;
			for(int i = 0; i < k; i++)
			{
				s += segs[i]->a.size();
				if (x < s) {
					segs[i]->del(x - lasts);
					break;
				}
				lasts = s;
			}
			n--;
		} else if (c == '+') {
			int x, add;
			cin >> x >> add;
			if (x == n)
			{
				int i = k - 1;
				segs[i]->ins(segs[i]->a.size(), add);
					if (segs[i]->a.size() >= 2 * sqrtn) {
						segment * t = new segment();
						t->init(segs[i]->split());
						for(int o = k; o > i + 1; o--) {
							segs[o] = segs[o - 1];
						}
						k++;
						segs[i + 1] = t;
					}
				n++;
				continue;
			}
			int s = 0, lasts = 0;
			for(int i = 0; i < k; i++)
			{
				s += segs[i]->a.size();
				if (x < s) {
					segs[i]->ins(x - lasts, add);
					if (segs[i]->a.size() >= 2 * sqrtn) {
						segment * t = new segment();
						t->init(segs[i]->split());
						for(int o = k; o > i + 1; o--) {
							segs[o] = segs[o - 1];
						}
						k++;
						segs[i + 1] = t;
					}
					break;
				}
				lasts = s;
			}
			n++;
		} else if (c == '?') {
			int l, r, x;
			cin >> l >> r >> x;
			int s = 0, lasts = 0;
			int ans = 0, l1 = -1, r1 = -1, li, ri;
			for(int i = 0; i < k; i++)
			{
				s += segs[i]->a.size();
				if (l < s && l1 == -1) {
					l1 = i;
					li = l - lasts;
				}
				if (r < s && r1 == -1)
				{
					r1 = i;
					ri = r - lasts;
					break;
				}
				lasts = s;
			}
			if (l1 == r1) 
			{
				for(int i = li; i <= ri; i++)
				{
					if (segs[l1]->a[i] <= x) {
						ans++;
					}
				}
				cout << ans << endl;
			} else {
				for(int i = li; i < segs[l1]->a.size(); i++)
				{
					if (segs[l1]->a[i] <= x) {
						ans++;
					}
				}
				for(int i = 0; i <= ri; i++)
				{
					if (segs[r1]->a[i] <= x) {
						ans++;
					}
				}
				for(int i = l1 + 1; i < r1; i++)
				{
					ans += segs[i]->query(x);
				}
				cout << ans << endl;
			}
		}
	}
	
	return 0;
}
