#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <iostream>
#include <string>
#include <vector>
#include <memory.h>
#include <algorithm>

using namespace std;

#define fore(i, b, e) for (int i = (int)b; i <= (int)e; i++)
#define pii pair <int, int>
#define mp make_pair
#define i64 long long

const int maxn = 1e5 + 5;

int n;
pii tree[maxn * 4];

pii get(int i, int L, int R, int A, int B)
{
	if (L >= B || A >= R)
		return mp(n + 1, 0);
	if (L >= A && R <= B)
		return tree[i];
	int m = (L + R) / 2;
	pii g1 = get(i * 2, L, m, A, min(B, m));
	pii g2 = get(i * 2 + 1, m, R, max(A, m), B);
	return mp(min(g1.first, g2.first), max(g1.second, g2.second));
}

void upd(int i, int L, int R, int pos)
{
	if (L + 1 == R)
	{
		tree[i] = mp(pos, pos);
		return;
	}
	int m = (L + R) / 2;
	if (pos < m)
		upd(i * 2, L, m, pos);
	else upd(i * 2 + 1, m, R, pos);
	tree[i] = mp(min(tree[i * 2].first, tree[i * 2 + 1].first), max(tree[i * 2].second, tree[i * 2 + 1].second));
}

pii a[maxn];

int main()
{
	freopen("minsum.in", "r", stdin);
	freopen("minsum.out", "w", stdout);
	scanf("%d", &n);
	fore(j, 1, n)
	{
		scanf("%d", &a[j].first);
		a[j].second = j;
	}
	sort(a + 1, a + n + 1);
	fore(j, 1, n * 4)
		tree[j] = mp(n + 1, 0);
	i64 answer = 0;
	fore(i, 1, n)
	{
		pii g1 = get(1, 1, n + 1, a[i].second + 1, n + 1);
		int next = g1.first;
		pii g2 = get(1, 1, n + 1, 1, a[i].second);
		int prev = g2.second;
		//printf("a[%d] = (%d %d) prev = %d next = %d\n", i, a[i].first, a[i].second, prev, next);
		/*i64 small = next - i;
		i64 big = next - prev - 1;
		i64 cnt = i - prev;
		i64 sum = (small + big) * cnt / 2;*/
		i64 t = next - a[i].second;
		i64 cnt = a[i].second - prev;
		i64 to_add = cnt * t * (i64)a[i].first;
		//cout << "to_add = " << to_add << endl;
		answer += to_add;
		upd(1, 1, n + 1, a[i].second);
	}
	cout << answer;

}