#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <iostream>
#include <string>
#include <vector>
#include <memory.h>
#include <algorithm>
#include <map>

using namespace std;

#define fore(i, b, e) for (int i = (int)b; i <= (int)e; i++)
#define forn(i, n) for (int i = 0; i < (int)n; i++)
#define pii pair <int, int>
#define mp make_pair
#define i64 long long
#define li long long
#define fi first
#define se second

const int max_block = 1000; 
const int maxn = 2e5 + 5;

int sz[max_block];
pii a[max_block][max_block];
int list[maxn];
int sqrtn;
int n, block_cnt;

inline void build()
{
	sqrtn = (int)sqrt((double)n) + 1;
	sz[0] = 0;
	int sum = 0;
	block_cnt = 1;
	forn(i, n)
	{
		sz[block_cnt - 1]++;
		a[block_cnt - 1][sz[block_cnt - 1] - 1] = mp(list[i], i - sum);
		if (sz[block_cnt - 1] >= sqrtn && (i != n - 1))
		{
			sum += sz[block_cnt - 1];
			block_cnt++;
			sz[block_cnt - 1] = 0;
		}
	}
	forn(j, block_cnt)
		sort(a[j], a[j] + sz[j]);
}

inline void check(int block)
{
	if (sz[block] == 0 || sz[block] >= 2 * sqrtn)
	{
		n = 0;
		forn(j, block_cnt)
		{
			forn(h, sz[j])
			{
				list[n + a[j][h].se] = a[j][h].fi;
			}
			n += sz[block_cnt];
		}
		build();
	}
}

inline void del(int i)
{
	int cur = 0;
	forn(block, block_cnt)
	{
		if (i >= cur && i < cur + sz[block])
		{
			forn(j, sz[block])
				if (a[block][j].se == i - cur)
				{
					fore(h, j, sz[block] - 2)
						a[block][h] = a[block][h + 1];
					break;
				}
			sz[block]--;
			forn(j, sz[block])
				if (a[block][j].se > i - cur)
					a[block][j].se--;
			check(block);
			break;
		}
		cur += sz[block];
	}
}

inline void add(int i, int x)
{
	int cur = 0;
	forn(block, block_cnt)
	{
		if (i >= cur && i <= cur + sz[block])
		{
			forn(j, sz[block])
				if (a[block][j].second >= i - cur)
					a[block][j].second++;
			fore(j, 0, sz[block])
				if (j == sz[block] || a[block][j].fi > x)
				{
					fore(h, j + 1, sz[block])
					{
						a[block][h] = a[block][h - 1];
						
					}
					a[block][j] = mp(x, i - cur);
					sz[block]++;
					check(block);
					break;
				}
		}
		cur += sz[block];
	}
}

inline int get(int L, int R, int x)
{
	int cur = 0;
	int ret = 0;
	forn(block, block_cnt)
	{
		if (cur >= R)
			break;
		
		int t = cur + sz[block];
		if (max(L, cur) < min(R, t))
		{
		}
		else
		{
			cur += sz[block];
			continue;
		}
		if (cur >= L && t <= R)
		{
			
			int to_add = upper_bound(a[block], a[block] + sz[block], mp(x, (int)1e9)) - a[block];
			ret += to_add;
		}
		else
		{
			forn(j, sz[block])
			{
				int absolute = a[block][j].se + cur;
				if (absolute >= L && absolute < R && a[block][j].fi <= x)
					ret++;
			}
		}
		cur += sz[block];
	}
	return ret;
}

void print()
{
	forn(i, block_cnt)
	{
		printf("block %d sz = %d\n", i, sz[i]);
		forn(j, sz[i])
			printf("(%d %d) ", a[i][j].first, a[i][j].second);
		printf("\n");
	}
	printf("====================\n");
}

int main()
{
	freopen("kthstat.in", "r", stdin);
	freopen("kthstat.out", "w", stdout);
	scanf("%d", &n);
	forn(j, n)
		scanf("%d", &list[j]);
	build();
	string s;
	while(cin >> s)
	{
		
		if (s == "-")
		{
			int i;
			
			scanf("%d", &i);
			//printf("DELETE %d\n", i);
			del(i);
		}
		else if (s == "+")
		{
			int i, x;
			scanf("%d%d", &i, &x);
			//printf("ADD %d %d\n", i, x);
			add(i, x);
		}
		else
		{
			int L, R, y;
			scanf("%d%d%d", &L, &R, &y);
			//printf("GET %d %d %d\n", L, R, y);
			int answer = get(L, R + 1, y);
			printf("%d\n", answer);
		}
		//print();
	}
}