#include <iostream>
#include <cstdio>
#include <set>
#include <map>
#include <queue>
#include <vector>
#include <fstream>
#include <sstream>
#include <algorithm>
#include <cassert>
#include <ctime>

#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define for1(i, n) for (int i = 1; i <= (int)(n); ++i)
#define ford(i, n) for (int i = (int)(n) - 1; i >= 0; --i)
#define all(x) (x).begin(), (x).end()
#define mp make_pair
#define pb push_back
#define fi first
#define se second

using namespace std;

typedef long long i64;
typedef vector<int> vi;
typedef vector<i64> vi64;
typedef pair<int, int> pii;
typedef unsigned int unt;
const int N = 300500;
int a[N];
int n;
int k;

struct Segment
{
	int l, r;
	vi el;
	Segment() {}
	Segment(int _l, int _r)
	{
		l = _l;
		r = _r;
		for (int i = l; i < r; i++)
			el.pb(a[i]);
		sort(all(el));
	}
	int get(int x) const
	{
		return upper_bound(all(el), x) - el.begin();
	}
	int size() const
	{
		return r - l;
	}
};
vector<Segment*> T;

int split(int pos)
{
	int cl = 0;
	int p = -1;
	for (int i = 0; i < T.size(); i++)
	if (cl + T[i]->size() > pos)
	{
		p = i;	
		break;
	}
	else
		cl += T[i]->size();
	if (p == -1) {
		assert(cl == pos);
		return T.size();
	}
	if (cl == pos)
	{
		return p; 
	}
	else
	{
		int l = T[p]->l;
		int r = T[p]->r;
		T.erase(T.begin() + p);
		int mid = l + pos - cl;
		
		T.insert(T.begin() + p, new Segment(mid, r));
		T.insert(T.begin() + p, new Segment(l, mid));
		return p + 1;
	}
}

void insert(int i, int x)
{
	a[n++] = x;
	int j = split(i);
	T.insert(T.begin() + j, new Segment(n - 1, n));
}

void erase(int i)
{
	int j = split(i);
	split(i + 1);
	T.erase(T.begin() + j);
}

int countLE(int l, int r, int x)
{
	r++;
	l = split(l), r = split(r);
	int res = 0;
	while (l < r) {
		res += T[l]->get(x);
		++l;
	}
	return res;
}

int na[N];
void recArray()
{
	int n1 = 0;
	forn (i, T.size())
	{
		for (int j = T[i]->l; j < T[i]->r; j++)
			na[n1++] = a[j];
	}
	n = n1;
	forn (i, n)
		a[i] = na[i];
	T.clear();
}

void initT()
{
	for (int i = 0; i < n;)
	{
		int ni = min(i + k, n);
		T.pb(new Segment(i, ni));
		i = ni;
	}
}

void gen()
{
	freopen("kthstat.in", "wt", stdout);
	int n = 100000;
	cout << n << endl;
	forn (i, n) cout << rand() << " "; cout << endl;
	int k = n;
	int sz = n;
	forn (i, k)
	{
		int t = rand() % 3;
		if (t == 0)
		{
			cout << "- " << rand() % sz << endl;
			--sz;
		}
		if (t == 1)
		{
			cout << "+ " << rand() % (sz + 1) << " " << rand() << endl;
			++sz;
		}
		if (t == 2)
		{
			int l = rand() % sz;
			int r = rand() % sz;
			if (l > r) swap(l, r);
			cout << "? " << l << " " << r << " " << rand() << endl;
		}
	}
	exit(0);
}

void eraseGreedy(vi& a, int x)
{
	a.erase(a.begin() + x);
}

void insertGreedy(vi& a, int x, int val)
{
	a.insert(a.begin() + x, val);
}

int countGreedy(const vi& a, int l, int r, int x)
{
	int res = 0;
	for (int i = l; i <= r; i++)
		res += (a[i] <= x);
	return res;
}

int main() {
	//gen();
	freopen("kthstat.in", "rt", stdin);
	freopen("kthstat.out", "wt", stdout);
	//freopen("kthstat.err", "wt", stderr);
	scanf("%d", &n);	
	forn (i, n) scanf("%d", &a[i]);
	vi grA(a, a + n);
	k = min(n, (int)sqrt(n * 17));
	initT();
	int maxQSegs = 5 * T.size();
	//cerr << T.size() << endl;
	char c;
	int x;
	int it = 0;
	while (scanf(" %c %d", &c, &x) == 2)
	{
		//if (++it % 100 == 0) cerr << it << endl;
		if (c == '-')
		{
			erase(x);
		//	eraseGreedy(grA, x);
		}
		if (c == '+')
		{
			int val;
			scanf("%d", &val);
			insert(x, val);
		//	insertGreedy(grA, x, val);
		}
		if (c == '?')
		{
			int l, r;
			scanf("%d%d", &r, &l);
			swap(l, x);
			printf("%d\n", countLE(l, r, x));
		//	assert(countGreedy(grA, l, r, x) == countLE(l, r, x));
		}
		if (T.size() >= maxQSegs)
		{
			recArray();
			initT();
		}
	}
	cerr << (double)clock() / CLOCKS_PER_SEC << endl;
	return 0;
}
