#include <iostream>
#include <ctime>
#include <cstdio>
#include <set>
#include <map>
#include <queue>
#include <vector>
#include <fstream>
#include <sstream>
#include <algorithm>

#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define for1(i, n) for (int i = 1; i <= (int)(n); ++i)
#define ford(i, n) for (int i = (int)(n) - 1; i >= 0; --i)
#define mp make_pair
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define fi first
#define se second

using namespace std;

typedef long long i64;
typedef vector<int> vi;
typedef vector<i64> vi64;
typedef pair<int, int> pii;

const int MAXN = 200000;

struct TNode {
	int L, R;
	int left, right;
	pii res;
	int val;

	TNode(int L = 0, int R = 0)
		: L(L)
		, R(R)
		, left(-1)
		, right(-1)
		, res(mp(0, L))
		, val(0)
	{
	}
};

const int MAXT = 3 * MAXN;
TNode tree[MAXT];
int tc = 0;

int buildTree(int L, int R) {
	int node = tc++;
	tree[node] = TNode(L, R);
	if (R - L > 1) {
		int M = (L + R) / 2;
		tree[node].left = buildTree(L, M);
		tree[node].right = buildTree(M, R);
	}
	return node;
}

inline void add(int node, int x) {
	tree[node].res.first += x;
	tree[node].val += x;
}

inline void push(int node) {
	TNode &n = tree[node];
	add(n.left, n.val);
	add(n.right, n.val);
	n.val = 0;
}

inline void relax(int node) {
	TNode &n = tree[node];
	n.res = min(tree[n.left].res, tree[n.right].res);
}

void addSeg(int node, int L, int R, int x) {
	if (L >= tree[node].R || tree[node].L >= R) return;
	if (L <= tree[node].L && tree[node].R <= R) {
		add(node, x);
		return;
	}
	push(node);
	addSeg(tree[node].left, L, R, x);
	addSeg(tree[node].right, L, R, x);
	relax(node);
}

struct TEvent {
	int L, R, x, type;

	TEvent(int L = 0, int R = 0, int x = 0, int type = 0)
		: L(L)
		, R(R)
		, x(x)
		, type(type)
	{
	}

	bool operator<(const TEvent &ev) const {
		if (x != ev.x) return x < ev.x;
		return type > ev.type;
	}
};

pii p[MAXN];

int uniform(int N) {
	int x = 0;
	forn(j, 3) x = (1LL * x * (1LL * RAND_MAX + 1) + rand()) % N;
	return x;
}

i64 sq(pii a) {
	return 1LL * a.first * a.first + 1LL * a.second * a.second;
}

bool better(pii a, pii b) {
	if (sq(a) != sq(b)) return sq(a) < sq(b);
	return a < b;
}

int main() {
	freopen("roi.in", "rt", stdin);
	freopen("roi.out", "wt", stdout);
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	int W, H, N;
	W = H = 1e9;
	N = 1e4;
	cin >> W >> H >> N;
	if (W == 0 || H == 0) {
		cout << "0\n0 0\n";
		return 0;
	}
	forn(i, N) {
		cin >> p[i].first >> p[i].second;
		//p[i] = mp(uniform(W + 1), uniform(H + 1));
	}
	int L = 1, R = min(W, H) + 1;
	pii res = mp(0, 0);
	while (R - L > 1) {
		int D = (L + R) / 2;
		vi ys;
		ys.pb(0);
		forn(i, N) {
			if (p[i].second + D <= H) ys.pb(p[i].second);
		}
		sort(all(ys));
		ys.erase(unique(all(ys)), ys.end());
		int K = ys.size();
		tc = 0;
		int root = buildTree(0, K);
		vector<TEvent> evs;
		forn(i, N) {
			int l = lower_bound(all(ys), p[i].se - D + 1) - ys.begin(), r = upper_bound(all(ys), p[i].se - 1) - ys.begin();
			if (p[i].first > 0) {
				evs.pb(TEvent(l, r, max(p[i].fi - D + 1, 0), 1));
				evs.pb(TEvent(l, r, p[i].fi - 1, -1));		
			}
		}
		evs.pb(TEvent(0, K, W - D, 0));

		sort(all(evs));
		int i = 0;
		int x = 0;
		bool ok = false;
		while (1) {
			int j = i;
			while (j < evs.size() && evs[j].x == x && evs[j].type == 1) {
				addSeg(root, evs[j].L, evs[j].R, 1);
				++j;
			}
			if (tree[root].res.first == 0) {
				pii r = mp(x, ys[tree[root].res.second]);
				if (!ok || better(r, res)) {
					res = r;
				}
				ok = true;
			}
			if (x >= W - D) break;
			while (j < evs.size() && evs[j].x == x && evs[j].type == -1) {
				addSeg(root, evs[j].L, evs[j].R, -1);
				++j;
			}
			i = j;
			if (i == evs.size()) break;
			x = evs[i].x;
		}
		if (ok) L = D;
		else R = D;
	}
	cout << L <<'\n';
	cout << res.fi << ' '<< res.se << '\n';
	cerr << 1.0 * clock() / CLOCKS_PER_SEC << '\n';
	return 0;
}
