#include <bits/stdc++.h>

#define pb puah_back
#define mp make_pair
#define all(x) (x).begin(),(x).end()
#define x first
#define y second

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef int itn;
typedef pair<int, int> PII;

struct node {
    int key;
    int que;
    int prior;
    int cnt;
    int cc;

    node *l, *r;

    node(int _key, int _q) {
        cc = cnt = 1;
        key = _key;
        que = _q;
        l = r = 0;
        prior = rand() * RAND_MAX + rand();
    }
};

int getCnt(node * v) {
    return v ? v->cnt : 0;
}

void updateCnt(node *v) {
    if (v) {
        v->cnt = v->cc + getCnt(v->l) + getCnt(v->r);
    }
}

void split(node * v, node * &l, node * &r, int cnt) {
    if (!v) {
        l = r = 0;
        return;
    }
    int x = getCnt(v->l);
    if (cnt <= x) {
        split(v->l, l, v->l, cnt), r = v;
    } else {
        split(v->r, v->r, r, cnt - x - v->cc), l = v;
    }
    updateCnt(v);
}

void split2(node * v, node * &l, node * &r, int cnt) {
    if (!v) {
        l = r = 0;
        return;
    }
    int x = getCnt(v->l) + v->cc;
    if (cnt < x) {
        split2(v->l, l, v->l, cnt), r = v;
    } else {
        split2(v->r, v->r, r, cnt - x - v->cc), l = v;
    }
    updateCnt(v);
}

void merge(node * &v, node *l, node *r) {
    if (!l || !r) {
        v = l ? l : r;
    } else {
        if (l->prior > r->prior) {
            merge(l->r, l->r, r), v = l;
        } else {
            merge(r->l, l, r->l), v = r;
        }
    }
    updateCnt(v);
}


const int N = 500000;

struct query {
    int type;
    int l;
    int r;
    int val;
} Q[N];

int idErase[N];

node * order[N];

vector <int> st[N + N];
vector <int> f[N + N];

int sz = 0;

void makeOrder(node * v) {
    if (!v) return;
    makeOrder(v->l);
    order[sz++] = v;
    makeOrder(v->r);
}

int s[N];

int get(int r) {
    int res = 0;
    for (; r >= 0; r &= r + 1, --r) {
        res += s[r];
    }
    return res;
}

void add(int r, int val) {
    for (; r < sz; r |= r + 1) {
        s[r] += val;
    }
}

int findPosL(int pos) {
    int l = 0, r = sz - 1;
    while (l < r) {
        int m = (l + r) / 2;
        //cerr << "ASDASDAD " << m << " " << get(m) << endl;
        if (get(m) < pos) {
            l = m + 1;
        } else {
            r = m;
        }
    }
    return l;
}

int findPosU(int pos) {
    int l = 1, r = sz;
    while (l < r) {
        int m = (l + r) / 2;
        if (get(m) <= pos) {
            l = m + 1;
        } else {
            r = m;
        }
    }
    return l - 1;
}

void add(int r, int val, vector <int> & F) {
    for (; r < (int)F.size(); r |= r + 1) {
        F[r] += val;
    }
}

int get(int r, vector <int> & F) {
    int res = 0;
    for (; r >= 0; r &= r + 1, --r) {
        res += F[r];
    }
    return res;
}

int get(int l, int r, int x) {
//    cerr << l << " " << r << endl;
//    for (int i = 0; i < sz; ++i) {
//        cerr << get(i) << " ";
//    }
//    cerr << endl;
    l = findPosL(l + 1);
    r = findPosU(r + 1);
    //cerr << l << " " << r << endl;
    //cerr << x << endl;
    int ans = 0;
    for (l += sz, r += sz; l <= r; l = (l + 1) >> 1, r = (r - 1) >> 1) {
        if (l & 1) {
            int u = upper_bound(all(st[l]), x) - st[l].begin() - 1;
            //cerr << u << endl;
            ans += get(u, f[l]);
        }
        if (!(r & 1)) {
            int u = upper_bound(all(st[r]), x) - st[r].begin() - 1;
            //cerr << u << endl;
            ans += get(u, f[r]);
        }
    }
    return ans;
}

void erase(int pos, int val) {
    for (pos += sz; pos; pos >>= 1) {
        int p = lower_bound(all(st[pos]), val) - st[pos].begin();
        add(p, -1, f[pos]);
    }
}
void ADD(int pos, int val) {
    for (pos += sz; pos; pos >>= 1) {
        int p = lower_bound(all(st[pos]), val) - st[pos].begin();
        add(p, 1, f[pos]);
    }
}

int posByQ[N];

void solve(){
    int n;
    scanf("%d", &n);
    node * root = 0;
    for (int i = 0; i < n; ++i) {
        int x;
        scanf("%d", &x);
        merge(root, root, new node(x, -i - 1));
    }

    char s[2];
    int v = -1;
    while (scanf("%s", s) == 1) {
        ++v;
        if (s[0] == '-') {
            int pos;
            scanf("%d", &pos);
            Q[v].type = 0;
            Q[v].l = pos;
            node *l, *r, *m;
            split2(root, l, r, pos);
            split(r, m, r, 1);
            m->cc = m->cnt = 0;
            idErase[v] = m->que;
            merge(r, m, r);
            merge(root, l, r);
        }
        if (s[0] == '+') {
            int pos, val;
            scanf("%d%d", &pos, &val);
            Q[v].type = 1;
            Q[v].l = pos;
            Q[v].val = val;
            node *l, *r, *m;
            split2(root, l, r, pos);
            m = new node(val, v);
            merge(r, m, r);
            merge(root, l, r);
        }
        if (s[0] == '?') {
            int l, r, x;
            scanf("%d%d%d", &l, &r, &x);
            Q[v].type = 2;
            Q[v].l = l;
            Q[v].r = r;
            Q[v].val = x;
        }
    }
    ++v;
    makeOrder(root);
    vector <int> numbers;
    for (int i = 0; i < sz; ++i) {
        numbers.push_back(order[i]->key);
        //cerr << order[i]->key << " " << order[i]->que << endl;
    }
    //cerr << endl;
    sort(all(numbers));
    numbers.resize(unique(all(numbers)) - numbers.begin());

    for (int i = 0; i < sz; ++i) {
        int NUM = lower_bound(all(numbers), order[i]->key) - numbers.begin();
        if (order[i]->que >= 0)
            posByQ[order[i]->que] = i;

        order[i]->key = NUM;
        st[sz + i].push_back(NUM);
        f[sz + i].resize(1);
    }
    for (int i = sz - 1; i > 0; --i) {
        merge(all(st[i + i]), all(st[i + i + 1]), back_inserter(st[i]));
        st[i].erase(unique(all(st[i])), st[i].end());
        f[i].resize(st[i].size());
    }
    for (int i = 0; i < sz; ++i) {
        if (order[i]->que < 0) {
            add(i, 1);
            ADD(i, order[i]->key);
        }
    }
    for (int i = 0; i < v; ++i) {
        if (Q[i].type == 0) {
            int pos = posByQ[idErase[i]];
            erase(pos, order[pos]->key);
            add(pos, -1);
        }
        if (Q[i].type == 1) {
            int pos = posByQ[i];
            add(pos, 1);
            ADD(pos, order[pos]->key);
        }
        if (Q[i].type == 2) {
            Q[i].val = upper_bound(all(numbers), Q[i].val) - numbers.begin() - 1;
            printf("%d\n", get(Q[i].l, Q[i].r, Q[i].val));
        }
    }
}

int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL

    solve();

    return 0;
}
