#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <ctime>
#include <cstring>
#include <algorithm>
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <deque>
using namespace std;
#define pb push_back
#define mp make_pair
#define sc second
#define fs first
#define int64 long long
#define ldb long double
#define sz(a) ((int) (a).size())

const int inf = 1000 * 1000 * 1000;
const int size = 200 * 1000 + 100;
const int rms = (1 << 20) - 1;
const int hrms = rms / 2;

inline long long sqr(long long x) {
	return x * x;
}

int tx, ty;
int n;
int x[size], y[size];
int ansx, ansy, stx, sty;
int rmq[rms + 1];
int change[rms + 1];
int ux[size], uy[size];
int dx[size], dy[size];
bool ansflag;
long long curad;
int m;
vector <int> ys;

void relaxans(int cx) {
	if (rmq[1] == 0) {
		int sum = 0;
		int p = 1;
		while (p <= hrms) {
			sum += change[p];
			if (sum + rmq[p * 2] == 0) {
				p = p * 2;
			} else {
				p = p * 2 + 1;
			}
		}

		int cy = ys[p - hrms - 1];

		//long long dst = sqr(cx) + sqr(cy);
		if (!ansflag) {
			ansflag = true;
			//curad = dst;
			ansx = cx;
			ansy = cy;
		} else {
			if (mp(cx, cy) < mp(ansx, ansy)) {
				//curad = dst;
				ansx = cx;
				ansy = cy;
			}
		}
	}
}

void recchange(int v, int lb, int rb, int i, int j, int d) {
	if (lb > j || rb < i)
		return;
	if (lb >= i && rb <= j) {
		change[v] += d;
		rmq[v] += d;
	
		return;
	}
	recchange(v * 2, lb, (lb + rb) / 2, i, j, d);
	recchange(v * 2 + 1, (lb + rb) / 2 + 1, rb, i, j, d);

	rmq[v] = min(rmq[v * 2], rmq[v * 2 + 1]) + change[v];
}

void changeval(int lb, int rb, int d) {
	recchange(1, 1, hrms + 1, lb + 1, rb + 1, d);
}

bool check(int k) {
	if (k == 1) {
		ansx = 0;
		ansy = 0;
		
		return true;
	}

	ansx = -1, ansy = -1;
	ansflag = false;

	for (int i = 0; i <= rms; i++) {
		rmq[i] = inf;
		change[i] = 0;
	}
	
	ys.clear();
	ys.pb(0);
	ys.pb(ty - k);
	for (int i = 0; i < n; i++) {
		for (int j = -1; j <= 1; j++) {
			int cy = y[i] + j;
			cy = max(0, min(ty - k, cy));
			ys.pb(cy);
		}
	}

	sort(ys.begin(), ys.end());
	ys.resize(unique(ys.begin(), ys.end())- ys.begin());

	m = ys.size();
	for (int i = 0; i < m; i++)
		rmq[hrms + 1 + i] = 0;
	for (int i = hrms; i > 0; i--)
		rmq[i] = min(rmq[i * 2], rmq[i * 2 + 1]);

	for (int i = 0; i < n; i++) {
		dy[i] = lower_bound(ys.begin(), ys.end(), max(0, y[i] - k + 1)) - ys.begin();
		uy[i] = lower_bound(ys.begin(), ys.end(), min(ty - k, y[i] - 1)) - ys.begin();
	}

	vector <pair <pair <int, int>, int> > events;

	events.pb(mp(mp(0, 1), -1));
	//events.pb(mp(mp(tx - k, 1), -1));

	for (int i = 0; i < n; i++) {
		events.pb(mp(mp(x[i] - k, 1), i));
		events.pb(mp(mp(x[i], 0), i));
	}

	sort(events.begin(), events.end());

	for (int i = 0; i < (int) events.size(); i++) {
		int num = events[i].sc;
		if (num == -1) {
			relaxans(events[i].fs.fs);
			continue;
		}
		if (events[i].fs.sc) {
			changeval(dy[num], uy[num], 1);
		} else {
			changeval(dy[num], uy[num], -1);
			if (events[i].fs.fs <= tx - k)
				relaxans(events[i].fs.fs);
		}
	}

	return ansflag;
}

int stupid() {
	int best = 1;
	stx = 0;
	sty = 0;

	for (int i = 0; i < tx; i++)
		for (int j = 0; j < ty; j++) {
			int cur = min(tx - i, ty - j);
			for (int k = 0; k < n; k++)
				if (x[k] > i && y[k] > j)
					cur = min(cur, max(x[k] - i, y[k] - j));
		
			if (cur > best) {
				best = cur;
				stx = i;
				sty = j;
			}

			/*
			if (cur == best && sqr(stx) + sqr(sty) > sqr(i) + sqr(j)) {
				stx = i;
				sty = j;
			}
			*/
		}

	return best;
}

int main() {
	/*
	freopen("roi.in", "w", stdout);
	int n = 50;
	int tx = 30;
	int ty = 50;
	cout << tx << ' ' << ty << endl;
	cout << n << endl;
	for (int i = 0; i < n; i++)
		cout << rand() % (tx + 1) << ' ' << rand() % (ty + 1) << endl;
	return 0;
	*/
	assert(freopen("roi.in", "r", stdin));
	assert(freopen("roi.out", "w", stdout));

	scanf("%d%d", &tx, &ty);
	
	if (min(tx, ty) == 0) {
		printf("0\n0 0\n");
		return 0;
	}
	
	vector <pair <int, int> > pts;

	scanf("%d", &n);
	for (int i = 0; i < n; i++) {
		scanf("%d%d", &x[i], &y[i]);
		if (x[i] > 0 && x[i] < tx && y[i] > 0 && y[i] < ty)
			pts.pb(mp(x[i], y[i]));
	}

	n = pts.size();
	for (int i = 0; i < n; i++) {
		x[i] = pts[i].fs;
		y[i] = pts[i].sc;
	}
	

	int lb = 1;
	int rb = min(tx, ty);

	while (lb < rb) {
		int mid = (lb + rb + 1) / 2;
		if (!check(mid))
			rb = mid - 1;
		else
			lb = mid;
	}

	check(lb);

	//int sans = stupid();
	//assert(lb == sans);
	//assert(ansx == stx);
	//assert(ansy == sty);

	printf("%d\n", lb);
	printf("%d %d\n", ansx, ansy);

	//cout << (clock() + 0.0) / CLOCKS_PER_SEC << endl;

	return 0;
}