#include <iostream> 
#include <cstdio> 
#include <map> 
#include <set> 
#include <algorithm> 
#include <cstdlib> 
#include <cstring>
#include <cassert>
#include <utility>
#include <vector>
#include <string>
#include <queue>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair< int, int > pii;
typedef vector< int > vi;

#define pb push_back
#define mp make_pair

int k = 300; 

struct Segment {
	vector<int> elem; 
	vector<int> sorted; 

	Segment(vector<int> cur) {
		elem = cur; 
		sort(cur.begin(), cur.end()); 
		sorted = cur; 
	}

	Segment(int x) {
		elem.pb(x); 
		sorted.pb(x); 
	}

	int calc(int val) {
		return upper_bound(sorted.begin(), sorted.end(), val) - sorted.begin(); 
	}
}; 

vector<Segment*> segs; 
int SZ = 0; 
int n; 
int a[1000000]; 

void rebuild() {
	vector<int> all; 
	for (int i = 0; i < segs.size(); i++) {
		all.insert(all.end(), segs[i]->elem.begin(), segs[i]->elem.end()); 
		delete segs[i]; 
	}

	segs.clear(); 
	int n = all.size(); 

	int len = (n + k - 1) / k;
	if (len) {
		for (int i = 0; i < (n + len - 1) / len; i++) {
			vector<int> cur(all.begin() + i * len, all.begin() + min((i + 1) * len, n)); 
			segs.pb(new Segment(cur)); 
		}
	}
}

int split(int i) {
	int all = 0; 
	int j = 0; 
	while (all + segs[j]->elem.size() <= i) {
		all += segs[j]->elem.size();
		j++;
	}
	i -= all; 
	if (i == 0) return j; 
	vector<int> nseg; 
	nseg.insert(nseg.end(), segs[j]->elem.begin() + i, segs[j]->elem.end());  
	segs[j]->elem.resize(i); 
	Segment * old = segs[j]; 
	segs[j] = new Segment(old->elem); 
	delete old; 
	segs.insert(segs.begin() + j + 1, new Segment(nseg)); 
	return j + 1; 
}

void Insert(int i, int val) {
	if (i == SZ) {
		segs.insert(segs.end(), new Segment(val));
		SZ++; 
		return; 
	}
	int x = split(i); 
	segs.insert(segs.begin() + x, new Segment(val)); 
	SZ++; 
}

void Erase(int i) {
	int x = split(i); 
	if (i == SZ - 1) {
		segs.pop_back(); 
		SZ--; 
		return; 
	}
	int y = split(i + 1); 
	segs.erase(segs.begin() + x); 
	SZ--;
}

int Calc(int x, int y, int val) {
	x = split(x); 
	if (y == SZ - 1) {
		y = segs.size(); 
	} else {
		y = split(y + 1); 
	}
	
	int res = 0; 
	for (int i = x; i < y; i++) {
		res += segs[i]->calc(val); 
	}
	return res; 
}

int
main()
{
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	
	ios::sync_with_stdio(false); 
	
	cin >> n; 
	SZ = n; 
	for (int i = 0; i < n; i++) 
	{
		cin >> a[i]; 
	}

	int len = (n + k - 1) / k;
	if (len) {
		for (int i = 0; i < (n + len - 1) / len; i++) {
			vector<int> cur; 
			for (int j = i * len; j < (i + 1) * len && j < n; j++) {
				cur.pb(a[j]); 
			}
			segs.push_back(new Segment(cur)); 
		}
	}
	
	char c; 
	while (cin >> c) {
		if (c == '-') {
			int x; 
			cin >> x; 
			Erase(x); 
		}
		if (c == '+') {
			int x, y; 
			cin >> x >> y; 
			Insert(x, y); 
		}
		if (c == '?') {
			int x, y, z; 
			cin >> x >> y >> z; 
			cout << Calc(x, y, z) << "\n";
		}
		if (segs.size() >= 3 * k) {
			rebuild(); 
		}
	}

	return 0;
}