#include <iostream> 
#include <cstdio> 
#include <map> 
#include <set> 
#include <algorithm> 
#include <cstdlib> 
#include <cstring>
#include <cassert>
#include <utility>
#include <vector>
#include <string>
#include <queue>

#define pb push_back
#define mp make_pair

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair< int, int > pii;
typedef vector< int > vi;

const int MAXK = 262144;

int x, y;
int n, curk;
vector< pair< int, int > > pnts;
vector< int > allX, allY;
int optX, optY;
map< int, int > cnt;

void
insertPnt(int y)
{
	cnt[y]++;
}

void
checkUpd(int from, int to, int stx, int w)
{
	if (to - from >= w && stx + w <= x) {
		if (optX > stx || optX == stx && optY > from) {
			optX = stx;
			optY = from;
		}
	}
}

void
checkAndDelete(int stx, int y, int w)
{
	map< int, int >::iterator it = cnt.find(y);
	--it->second;
	map< int, int >::iterator it1 = it, it2 = it;
	it1--, it2++;
	if (it->second == 0) {
		checkUpd(it1->first, it2->first, stx, w);
		cnt.erase(it);
	} else {
		if (it != cnt.begin()) {
			checkUpd(it1->first, y, stx, w);
		}
		if (it2 != cnt.end()) {
			checkUpd(y, it2->first, stx, w);
		}
	}
}

bool
canFind(int w)
{
	cnt.clear();
	cnt[0]++;
	cnt[y]++;
	optX = 2 * x, optY = 2 * y;
	int p1 = 0, p2 = 0;
	int nn = pnts.size();
	while (p2 < nn && pnts[p2].first < w) {
		insertPnt(pnts[p2].second);
		++p2;
	}
	vector< int > npn;
	for (map< int, int >::iterator it = cnt.begin(); it != cnt.end(); ++it) {
		npn.push_back(it->first);
	}
	for (int i = 0; i < int(npn.size()) - 1; ++i) {
		if (npn[i + 1] - npn[i] >= w) {
			if (optX > 0 || optX == 0 && optY > npn[i]) {
				optX = 0;
				optY = npn[i];
			}
		}
	}
	while (p1 < nn || p2 < nn) {
		if (p1 < nn && (p2 == nn || pnts[p1].first <= pnts[p2].first - w)) {
			checkAndDelete(pnts[p1].first, pnts[p1].second, w);
			++p1;
		} else {
			insertPnt(pnts[p2].second);
			++p2;
		}
	}
	return optX <= x && optY <= y;
}

int
main()
{
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	scanf("%d%d", &x, &y);
	allX.clear(); 
	allY.clear();
	allX.push_back(x);
	allY.push_back(y);
	scanf("%d", &n);
	pnts.resize(n);
	for (int i = 0; i < n; ++i) {
		scanf("%d%d", &pnts[i].first, &pnts[i].second);
		allX.push_back(pnts[i].first);
		allY.push_back(pnts[i].second);
	}
	pnts.push_back(make_pair(0, 0));
	pnts.push_back(make_pair(0, y));
	pnts.push_back(make_pair(x, 0));
	pnts.push_back(make_pair(x, y));
	sort(allX.begin(), allX.end());
	allX.resize(unique(allX.begin(), allX.end()) - allX.begin());
	sort(allY.begin(), allY.end());
	allY.resize(unique(allY.begin(), allY.end()) - allY.begin());
	for (int i = 0; i < n; ++i) {
		//pnts[i].first = lower_bound(allX.begin(), allX.end(), pnts[i].first) - allX.begin();
		//pnts[i].second = lower_bound(allY.begin(), allY.end(), pnts[i].second) - allY.begin();
	}
	sort(pnts.begin(), pnts.end());
	curk = 2;
	while (curk < allY.size()) {
		curk *= 2;
	}
	int l = 0, r = min(x, y) + 1;
	while (l < r - 1) {
		int mid = (l + r) / 2;
		if (canFind(mid)) {
			l = mid;
		} else {
			r = mid;
		}
	}
	canFind(l);
	printf("%d\n%d %d\n", l, optX, optY);
	return 0;
}