#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#ifdef _WIN32
#define LLD "%I64d"
#else
#define LLD "%lld"
#endif
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define y0 yy0
#define y1 yy1
#define next _next
#define prev _prev
#define rank _rank
#define link _link
#define hash _hash
#define fs first
#define sc second

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int inf = int(1e9);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));
const int N = int(1e5) + 100;

int a[N], prev[N], rank[N], sz[N], val[N], st[N];

int get(int a) {
	if (prev[a] != a) {
		prev[a] = get(prev[a]);
	}
	return prev[a];
}

inline void merge(int a, int b, int c) {
	assert(a != b);
	if (rank[a] < rank[b]) {
		swap(a, b);
	}
	prev[b] = a;
	sz[a] += sz[b];
	val[a] = c;
	if (rank[a] == rank[b]) {
		++rank[a];
	}
}

int main() {
#ifdef LOCAL42
#define TASK "B"
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#else

#endif
	int n;
	scanf("%d", &n);
	for (int i = 0; i < n; ++i) {
		scanf("%d", &a[i]);
		prev[i] = i;
		rank[i] = 1;
		sz[i] = 1;
		val[i] = a[i];
	}
	ll sum = 0, ans = 0;
	int k = 0;
	for (int i = 0; i < n; ++i) {
		while (k > 0 && a[st[k - 1]] > a[i]) {
			int pa = get(st[--k]), b = get(i);
			sum += 1LL * sz[pa] * (a[i] - val[pa]);
			merge(pa, b, a[i]);
		}
		sum += a[i];
		ans += sum;
		st[k++] = i;
	}
	cout << ans << endl;
	return 0;
}
