#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#ifdef _WIN32
#define LLD "%I64d"
#else
#define LLD "%lld"
#endif
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define y0 yy0
#define y1 yy1
#define next _next
#define prev _prev
#define rank _rank
#define link _link
#define hash _hash
#define fs first
#define sc second

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int inf = int(1e9);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));
const int N = int(2e5) + 100;
const int K = 1500;

int m;
int a[N];
int sz[N / K + 10];
int b[N / K + 10][2 * K + 10], c[N / K + 10][2 * K + 10];

inline void rebuild(int n) {
	m = 0;
	for (int i = 0; i < n; i += K) {
		sz[m] = 0;
		for (int j = i; j < min(i + K, n); ++j) {
			b[m][sz[m]] = a[j];
			c[m][sz[m]++] = a[j];
		}
		sort(c[m], c[m] + sz[m]);
		++m;
	}
	if (m == 0) {
		sz[0] = 0;
		++m;
	}
}

inline pii find_pos(int pos) {
	for (int i = 0; i < m; ++i) {
		if (sz[i] <= pos) {
			pos -= sz[i];
			continue;
		}
		return mp(i, pos);
	}
	return mp(m - 1, sz[m - 1]);
}

inline void add(int pos, int x) {
	pii p = find_pos(pos);
	for (int i = sz[p.fs]; i > p.sc; --i) {
		b[p.fs][i] = b[p.fs][i - 1];
	}
	b[p.fs][p.sc] = x;
	int ptr = 0;
	while (ptr < sz[p.fs] && c[p.fs][ptr] < x) {
		++ptr;
	}
	for (int i = sz[p.fs]; i > ptr; --i) {
		c[p.fs][i] = c[p.fs][i - 1];
	}
	c[p.fs][ptr] = x;
	++sz[p.fs];
}

inline void del(int pos) {
	pii p = find_pos(pos);
	int val = b[p.fs][p.sc];
	for (int i = p.sc; i + 1 < sz[p.fs]; ++i) {
		b[p.fs][i] = b[p.fs][i + 1];
	}
	int ptr = 0;
	while (ptr < sz[p.fs] && c[p.fs][ptr] != val) {
		++ptr;
	}
	assert(ptr < sz[p.fs]);
	for (int i = ptr; i + 1 < sz[p.fs]; ++i) {
		c[p.fs][i] = c[p.fs][i + 1];
	}
	--sz[p.fs];
}

inline void rebuild() {
	int n = 0;
	for (int i = 0; i < m; ++i) {
		for (int j = 0; j < sz[i]; ++j) {
			a[n++] = b[i][j];
		}
	}
	rebuild(n);
}

inline int calc(int l, int r, int x) {
	pii pl = find_pos(l), pr = find_pos(r);
	if (pl.fs == pr.fs) {
		int ans = 0;
		for (int i = pl.sc; i <= pr.sc; ++i) {
			ans += (b[pl.fs][i] <= x);
		}
		return ans;
	}
	int ans = 0;
	for (int i = pl.fs + 1; i < pr.fs; ++i) {
		ans += upper_bound(c[i], c[i] + sz[i], x) - c[i];
	}
	for (int i = pl.sc; i < sz[pl.fs]; ++i) {
		ans += (b[pl.fs][i] <= x);
	}
	for (int i = 0; i <= pr.sc; ++i) {
		ans += (b[pr.fs][i] <= x);
	}
	return ans;
}

int main() {
#ifdef LOCAL42
#define TASK "C"
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#else

#endif
	int n;
	scanf("%d", &n);
	for (int i = 0; i < n; ++i) {
		scanf("%d", &a[i]);
	}
	rebuild(n);
	int q = 0;
	char ch;
	while (scanf(" %c", &ch) == 1) {
		++q;
		if (q % K == 0) {
			rebuild();
		}
		if (ch == '+') {
			int pos, x;
			scanf("%d %d", &pos, &x);
			add(pos, x);
			continue;
		}
		if (ch == '-') {
			char ch;
			int pos;
			scanf("%d", &pos);
			del(pos);
			continue;
		}
		assert(ch == '?');
		int l, r, x;
		scanf("%d %d %d", &l, &r, &x);
		printf("%d\n", calc(l, r, x));
	}
	return 0;
}
