#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#ifdef _WIN32
#define LLD "%I64d"
#else
#define LLD "%lld"
#endif
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define y0 yy0
#define y1 yy1
#define next _next
#define prev _prev
#define rank _rank
#define link _link
#define hash _hash
#define fs first
#define sc second

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int inf = int(1e9) + 42;
const double eps = 1e-9;
const double pi = 4 * atan(double(1));
const int N = int(2e5) + 100;

struct seg {

	int start, len;

	seg() {}

	seg(int start, int len) {
		this->start = start;
		this->len = len;
	}

};

seg operator + (const seg &a, const seg &b) {
	assert(a.start + a.len == b.start);
	return seg(a.start, a.len + b.len);
}

bool operator < (const seg &a, const seg &b) {
	if (a.len != b.len) {
		return a.len < b.len;
	}
	return a.start > b.start;
}

struct tans {

	seg l, r, ans;
	int w;

	tans() {}

};

tans operator + (const tans &a, const tans &b) {
	tans c;
	c.l = ((a.l.len == a.w && b.l.len > 0) ? a.l + b.l : a.l);
	c.r = ((b.r.len == b.w && a.r.len > 0) ? a.r + b.r : b.r);
	c.ans = max(a.ans, b.ans);
	if (a.r.len > 0 && b.l.len > 0) {
		c.ans = max(c.ans, a.r + b.l);
	}
	c.w = a.w + b.w;
	return c;
}

int maxv, ans, sx, sy;
int x[N], num[N], y[N], cnt[N];
pii a[N];
vi lst[N];
tans rmq[8 * N];

inline void calc(int v) {
	rmq[v] = rmq[v * 2] + rmq[v * 2 + 1];
}

inline void update(int pos, bool active) {
	pos += maxv;
	assert(rmq[pos].w == 1);
	rmq[pos].l.len = rmq[pos].r.len = active;
	rmq[pos].r.start += (active ? -1 : 1);
	rmq[pos].ans = rmq[pos].r;
	while (pos > 1) {
		pos /= 2;
		calc(pos);
	}
}

inline int find_start(int len) {
	int v = 1, res = inf;
	while (v < maxv) {
		res = min(res, rmq[v].ans.start - 1);
		if (rmq[v * 2].ans.len + 1 >= len) {
			v *= 2;
		} else if (rmq[v * 2 + 1].ans.len + 1 >= len) {
			v = v * 2 + 1;
		} else {
			break;
		}
	}
	return res;
}

inline void relax(int l, int r) {
	int len = min(rmq[1].ans.len + 1, x[r] - x[l]);
	int cx = x[l], cy = find_start(len);
	if (len > ans || (len == ans && mp(cx, cy) < mp(sx, sy))) {
		ans = len;
		sx = cx;
		sy = cy;
	}
}

int ky;

inline void init() {
	for (int i = 0; i < ky; ++i) {
		cnt[i] = 0;
	}
	maxv = 1;
	while (maxv < 2 * ky - 1) {
		maxv *= 2;
	}
	int ptr = 0;
	for (int i = 0; i < ky; ++i) {
		num[i] = ptr;
		rmq[maxv + ptr].l = rmq[maxv + ptr].r = seg(y[i], 1);
		rmq[maxv + ptr].w = 1;
		rmq[maxv + ptr].ans = seg(y[i], 1);
		++ptr;
		if (i + 1 < ky) {
			rmq[maxv + ptr].l = rmq[maxv + ptr].r = seg(y[i] + 1, y[i + 1] - y[i] - 1);
			rmq[maxv + ptr].w = y[i + 1] - y[i] - 1;
			rmq[maxv + ptr].ans = seg(y[i] + 1, y[i + 1] - y[i] - 1);
			++ptr;
		}
	}
	for (int i = ptr; i < maxv; ++i) {
		rmq[i + maxv].l = rmq[i + maxv].r = seg(y[ky - 1] + 1, 0);
		rmq[i + maxv].w = 0;
		rmq[i + maxv].ans = seg(y[ky - 1] + 1, 0);
	}
	for (int i = maxv - 1; i > 0; --i) {
		calc(i);
	}
	assert(num[ky - 1] == 2 * ky - 2);
	update(num[0], false);
	update(num[ky - 1], false);
}

int main() {
#ifdef LOCAL42
#define TASK "E"
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#else

#endif
	int X, Y;
	scanf("%d %d", &X, &Y);
	if (X == 0 || Y == 0) {
		cout << 0 << endl;
		cout << 0 << " " << 0 << endl;
		return 0;
	}
	int n;
	scanf("%d", &n);
	int kx = 0;
	ky = 0;
	x[kx++] = 0;
	x[kx++] = X;
	y[ky++] = 0;
	y[ky++] = Y;
	for (int i = 0; i < n; ++i) {
		scanf("%d %d", &a[i].fs, &a[i].sc);
		x[kx++] = a[i].fs;
		y[ky++] = a[i].sc;
	}
	sort(x, x + kx);
	kx = unique(x, x + kx) - x;
	sort(y, y + ky);
	ky = unique(y, y + ky) - y;
	for (int i = 0; i < n; ++i) {
		a[i].fs = lower_bound(x, x + kx, a[i].fs) - x;
		a[i].sc = lower_bound(y, y + ky, a[i].sc) - y;
		if (a[i].sc == 0 || a[i].sc == ky - 1) {
			continue;
		}
		lst[a[i].fs].pb(a[i].sc);
	}
	init();
	int l = kx - 1, r = kx - 1;
	ans = sx = sy = 0;
	while (l > 0) {
		if (l < r) {
			for (int i = 0; i < sz(lst[l]); ++i) {
				cnt[lst[l][i]]++;
				if (cnt[lst[l][i]] == 1) {
					update(num[lst[l][i]], false);
				}
			}
		}
		--l;
		relax(l, r);
		while (x[r] - x[l] > rmq[1].ans.len + 1) {
			if (l < r - 1) {
				for (int i = 0; i < sz(lst[r - 1]); ++i) {
					cnt[lst[r - 1][i]]--;
					if (cnt[lst[r - 1][i]] == 0) {
						update(num[lst[r - 1][i]], true);
					}
				}
			}
			--r;
			relax(l, r);
		}
	}
	init();
	l = r = kx - 1;
	while (l > 0) {
		if (l < r) {
			for (int i = 0; i < sz(lst[l]); ++i) {
				cnt[lst[l][i]]++;
				if (cnt[lst[l][i]] == 1) {
					update(num[lst[l][i]], false);
				}
			}
		}
		--l;
		relax(l, r);
		while (r - 1 >= l && x[r - 1] - x[l] >= ans) {
			if (l < r - 1) {
				for (int i = 0; i < sz(lst[r - 1]); ++i) {
					cnt[lst[r - 1][i]]--;
					if (cnt[lst[r - 1][i]] == 0) {
						update(num[lst[r - 1][i]], true);
					}
				}
			}
			--r;
			relax(l, r);
		}
	}
	cout << ans << endl;
	cout << sx << " " << sy << endl;
	return 0;
}
