#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <bitset>
#include <sstream>
#include <cstdio>
#include <cstring>
#include <cmath>
#include <climits>
#include <cctype>
#include <cstdlib>
using namespace std;

typedef long long LL;
typedef LL ll;

typedef pair<int, int> pii;
const int kInf = 1000 * 1000 * 1000;

const int kN = 1 << 17;

inline pii Combine(const pii& lhs, const pii& rhs) {
  if (lhs.first < rhs.first)
    return lhs;
  return rhs;
}

struct SegmentTree {
  pii data[2 * kN - 1];

  int L(int i) { return i * 2 + 1; }
  int R(int i) { return i * 2 + 2; }

  void Set(int pos, int x, int ind = 0, int tl = 0, int tr = kN - 1) {
    if (tl == tr) {
      data[ind] = {x, pos};
      return;
    }
    int tm = (tl + tr) >> 1;
    if (pos <= tm)
      Set(pos, x, L(ind), tl, tm);
    else
      Set(pos, x, R(ind), tm + 1, tr);
    data[ind] = Combine(data[L(ind)], data[R(ind)]);

  }

  pii Get(int l, int r, int ind = 0, int tl = 0, int tr = kN - 1) {
    if (l == tl && r == tr) {
      return data[ind];
    }
    int tm = (tl + tr) >> 1;
    if (r <= tm)
      return Get(l, r, L(ind), tl, tm);
    else if (tm < l)
      return Get(l, r, R(ind), tm + 1, tr);
    else
      return Combine(Get(l, tm, L(ind), tl, tm), Get(tm + 1, r, R(ind), tm + 1, tr));
  }
};

SegmentTree tree;

ll F(int l, int r) {
  if (r < l) {
    return 0;
  }
  if (l == r) {
    return tree.Get(l, r).first;
  }
  pii p = tree.Get(l, r);
  ll res = (ll)(p.second - l + 1) * (r - p.second + 1) * p.first;
  return res + F(l, p.second - 1) + F(p.second + 1, r);
}

int main() {
  std::ios_base::sync_with_stdio(false);
  int n;
  cin >> n;
  for (int i = 0; i < n; ++i) {
    int x;
    cin >> x;
    tree.Set(i, x);
  }
  cout << F(0, n - 1);
  return 0;
}