#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <bitset>
#include <sstream>
#include <cstdio>
#include <cstring>
#include <cmath>
#include <climits>
#include <cctype>
#include <cstdlib>
using namespace std;

#define FOR(i,a,b) for(int i=(a);i<(b);i++)
#define ROF(i,a,b) for(int i=(b)-1;i>=(a);i--)

typedef long long LL;
typedef LL ll;

typedef pair<int, int> pii;
const int kInf = 1000 * 1000 * 1000;

const int MAXN = 262144;
int n;
pii trees[MAXN];
int X, Y;

int ycoords[MAXN];

pii answer;
bool test(int size) {
  int nc = 2;
  ycoords[0] = 0;
  ycoords[1] = Y;
  FOR(i, 0, n) {
    if (trees[i].first < size) {
      ycoords[nc++] = trees[i].second;
    }
  }
  sort(ycoords, ycoords + nc);
  FOR(i, 1, nc) {
    if (ycoords[i] - ycoords[i - 1] >= size) {
      answer = pii(0, ycoords[i - 1]);
      return true;
    }
  }
  multiset<int> scan;
  scan.insert(0);
  scan.insert(Y);
  int left = 0;
  int right = 0;
  for (int i = 0; i < n; i++) {
    if (trees[i].first + size > X) {
      break;
    }
    while (right < n && trees[right].first < trees[i].first + size) {
      scan.insert(trees[right++].second);
    }
    while (left < right && trees[left].first <= trees[i].first) {
      scan.erase(trees[left++].second);
    }
    int top = *(--scan.upper_bound(trees[i].second));
    int bottom = *scan.lower_bound(trees[i].second);
    if (bottom - top >= size) {
      answer = pii(trees[i].first, top);
      return true;
    }
  }
  return false;
}

int main() {
  scanf("%d%d%d", &X, &Y, &n);
  FOR(i, 0, n) scanf("%d%d", &trees[i].first, &trees[i].second);
  sort(trees, trees + n);

  int Left = 1;
  int Right = min(X, Y);
  while (Left < Right) {
    int Mid = (Left + Right + 1) / 2;
    if (test(Mid)) {
      Left = Mid;
    } else {
      Right = Mid - 1;
    }
  }
  test(Left);
  printf("%d\n%d %d", Left, answer.first, answer.second);

  return 0;
}
