#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <bitset>
#include <sstream>
#include <cstdio>
#include <cstring>
#include <cmath>
#include <climits>
#include <cctype>
#include <cstdlib>
using namespace std;

#define FOR(i,a,b) for(int i=(a);i<(b);i++)
#define ROF(i,a,b) for(int i=(b)-1;i>=(a);i--)

typedef long long LL;
typedef LL ll;

typedef pair<int, int> pii;
const int kInf = 1000 * 1000 * 1000;

const int MAXN = 262144;

struct Tree {
  int tmin[MAXN * 2];
  int tmax[MAXN * 2];
  int counts[MAXN];

  void clear() {
    FOR(i, 0, MAXN * 2) tmin[i] = MAXN, tmax[i] = 0;
    FOR(i, 0, MAXN) counts[i] = 0;
  }
  void insert(int i) {
    if (!counts[i]++) {
      i += MAXN;
      tmin[i] = tmax[i] = i - MAXN;
      for (i /= 2; i; i /= 2) {
        tmin[i] = min(tmin[i + i], tmin[i + i + 1]);
        tmax[i] = max(tmax[i + i], tmax[i + i + 1]);
      }
    }
  }
  void erase(int i) {
    if (!--counts[i]) {
      i += MAXN;
      tmin[i] = MAXN;
      tmax[i] = 0;
      for (i /= 2; i; i /= 2) {
        tmin[i] = min(tmin[i + i], tmin[i + i + 1]);
        tmax[i] = max(tmax[i + i], tmax[i + i + 1]);
      }
    }
  }
  int getmin(int l, int r) {
    l += MAXN, r += MAXN;
    int res = min(tmin[l], tmin[r]);
    while (l < r - 1) {
      if (!(l & 1)) res = min(res, tmin[l + 1]);
      if (r & 1) res = min(res, tmin[r - 1]);
      l /= 2; r /= 2;
    }
    return res;
  }
  int getmax(int l, int r) {
    l += MAXN, r += MAXN;
    int res = max(tmax[l], tmax[r]);
    while (l < r - 1) {
      if (!(l & 1)) res = max(res, tmax[l + 1]);
      if (r & 1) res = max(res, tmax[r - 1]);
      l /= 2; r /= 2;
    }
    return res;
  }
};

Tree scan;

int n;
pii trees[MAXN];
int treey[MAXN];
int ylist[MAXN];
int numy = 0;
int X, Y;

int ycoords[MAXN];

pii answer;
bool test(int size) {
  int nc = 2;
  ycoords[0] = 0;
  ycoords[1] = Y;
  FOR(i, 0, n) {
    if (trees[i].first < size) {
      ycoords[nc++] = trees[i].second;
    }
  }
  sort(ycoords, ycoords + nc);
  FOR(i, 1, nc) {
    if (ycoords[i] - ycoords[i - 1] >= size) {
      answer = pii(0, ycoords[i - 1]);
      return true;
    }
  }
  scan.clear();
  scan.insert(0);
  scan.insert(numy - 1);
  int left = 0;
  int right = 0;
  for (int i = 0; i < n; i++) {
    if (trees[i].first + size > X) {
      break;
    }
    while (right < n && trees[right].first < trees[i].first + size) {
      scan.insert(treey[right++]);
    }
    while (left < right && trees[left].first <= trees[i].first) {
      scan.erase(treey[left++]);
    }
    int top = scan.getmax(0, treey[i]);
    int bottom = scan.getmin(treey[i], numy - 1);
    if (ylist[bottom] - ylist[top] >= size) {
      answer = pii(trees[i].first, ylist[top]);
      return true;
    }
  }
  return false;
}

int main() {
  scanf("%d%d%d", &X, &Y, &n);
  FOR(i, 0, n) scanf("%d%d", &trees[i].first, &trees[i].second);
  sort(trees, trees + n);

  ylist[numy++] = 0;
  ylist[numy++] = Y;
  FOR(i, 0, n) {
    ylist[numy++] = trees[i].second;
  }
  sort(ylist, ylist + numy);
  numy = unique(ylist, ylist + numy) - ylist;
  FOR(i, 0, n) {
    treey[i] = lower_bound(ylist, ylist + numy, trees[i].second) - ylist;
  }

  if (min(X, Y) == 0) {
    printf("0\n0 0");
    return 0;
  }

  int Left = 1;
  int Right = min(X, Y);
  while (Left < Right) {
    int Mid = (Left + Right + 1) / 2;
    if (test(Mid)) {
      Left = Mid;
    } else {
      Right = Mid - 1;
    }
  }
  test(Left);
  printf("%d\n%d %d", Left, answer.first, answer.second);

  return 0;
}
