//#pragma comment(linker, "/STACK:256000000")

//#include <iostream>
//#include <windows.h>
#include <algorithm>
//#include <string>
//#include <vector>
//#include <set>
//#include <map>
//#include <queue>
//#include <bitset>
//#include <sstream>
#include <cstdio>
#include <cstring>
#include <cmath>
//#include <climits>
//#include <cctype>
#include <cstdlib>
using namespace std;

#define FOR(i,a,b) for(int i=(a);i<(b);i++)
#define ROF(i,a,b) for(int i=(b)-1;i>=(a);i--)

typedef long long LL;
typedef LL ll;

typedef pair<int, int> pii;
const int kInf = 1000 * 1000 * 1000;

const int MAXN = 262144;

struct Tree {
  int tmin[MAXN * 2];
  int tmax[MAXN * 2];
  int counts[MAXN];

  void clear() {
    FOR(i, 0, MAXN * 2) tmin[i] = MAXN, tmax[i] = 0;
    FOR(i, 0, MAXN) counts[i] = 0;
  }
  void insert(int i) {
    if (!counts[i]++) {
      i += MAXN;
      int z = i - MAXN;
      tmin[i] = tmax[i] = z;
      int m = 3;
      while (i > 1 && m) {
        int next = i >> 1;
        if (i & 1) {
          if ((m & 1) && tmin[i - 1] == MAXN) {
            tmin[next] = tmin[i];
          } else {
            m &= ~1;
          }
          tmax[next] = tmax[i];
        } else {
          if ((m & 2) && tmax[i + 1]) {
            tmax[next] = tmax[i];
          } else {
            m &= ~2;
          }
          tmin[next] = tmin[i];
        }
        i = next;
      }
    }
  }
  void erase(int i) {
    if (!--counts[i]) {
      i += MAXN;
      tmin[i] = MAXN;
      tmax[i] = 0;
      for (i >>= 1; i; i >>= 1) {
        tmin[i] = min(tmin[i + i], tmin[i + i + 1]);
        tmax[i] = max(tmax[i + i], tmax[i + i + 1]);
      }
    }
  }
  int getmin(int l) {
    l += MAXN;
    if (tmin[l] != MAXN) return tmin[l];
    while (l > 1) {
      if (!(l & 1) && tmin[l + 1] != MAXN) return tmin[l + 1];
      l >>= 1;
    }
    return MAXN;
  }
  int getmax(int r) {
    r += MAXN;
    if (tmax[r]) return tmax[r];
    while (r > 1) {
      if ((r & 1) && tmax[r - 1]) return tmax[r - 1];
      r >>= 1;
    }
    return 0;
  }
};

int n;
pii trees[MAXN];
int treey[MAXN];
int ylist[MAXN];
int numy = 0;
int X, Y;

int ycoords[MAXN];

Tree scan;

pii answer;
bool test(int size) {
  int nc = 2;
  ycoords[0] = 0;
  ycoords[1] = Y;
  FOR(i, 0, n) {
    if (trees[i].first < size) {
      ycoords[nc++] = trees[i].second;
    }
  }
  sort(ycoords, ycoords + nc);
  FOR(i, 1, nc) {
    if (ycoords[i] - ycoords[i - 1] >= size) {
      answer = pii(0, ycoords[i - 1]);
      return true;
    }
  }
  scan.clear();
  scan.insert(0);
  scan.insert(numy - 1);
  int left = 0;
  int right = 0;
  for (int i = 0; i < n; i++) {
    if (trees[i].first + size > X) {
      break;
    }
    while (right < n && trees[right].first < trees[i].first + size) {
      scan.insert(treey[right++]);
    }
    while (left < right && trees[left].first <= trees[i].first) {
      scan.erase(treey[left++]);
    }
    int top = scan.getmax(treey[i]);
    int bottom = scan.getmin(treey[i]);
    if (ylist[bottom] - ylist[top] >= size) {
      answer = pii(trees[i].first, ylist[top]);
      return true;
    }
  }
  return false;
}

int main() {
//  int tstart = GetTickCount();
  scanf("%d%d%d", &X, &Y, &n);
  FOR(i, 0, n) scanf("%d%d", &trees[i].first, &trees[i].second);
  sort(trees, trees + n);

  ylist[numy++] = 0;
  ylist[numy++] = Y;
  FOR(i, 0, n) {
    ylist[numy++] = trees[i].second;
  }
  sort(ylist, ylist + numy);
  numy = unique(ylist, ylist + numy) - ylist;
  FOR(i, 0, n) {
    treey[i] = lower_bound(ylist, ylist + numy, trees[i].second) - ylist;
  }

  if (min(X, Y) == 0) {
    printf("0\n0 0");
    return 0;
  }

//  printf("\nTime: %.3f\n", double(GetTickCount() - tstart) * 0.001);
  int Left = 1;
  int Right = min(X, Y);
//  int cnt = 1;
  while (Left < Right) {
    int Mid = (Left + Right + 1) / 2;
//    cnt++;
    if (test(Mid)) {
      Left = Mid;
    } else {
      Right = Mid - 1;
    }
  }
  test(Left);
  printf("%d\n%d %d", Left, answer.first, answer.second);

//  printf("\nCount: %d\nTime: %.3f\n", cnt, double(GetTickCount() - tstart) * 0.001);

  return 0;
}
