#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>

using namespace std;

#define fs first
#define sc second

#define pb push_back
#define mp make_pair

#define forn(i, n) for(int i = 0; i < (int)n; ++i)
#define all(x) (x).begin(), (x).end()

const int MAXN = 100 * 1000 + 5, K = 500;
int a[2 * MAXN], n;

struct Segment {
    vector<int> vec, sorted;

    Segment(int l, int r) {
        for(int i = l; i < r; i++) {
            vec.push_back(a[i]);
            sorted.push_back(a[i]);
        }
        sort(sorted.begin(), sorted.end());
    }

    Segment(Segment *seg, int l, int r) {
        for(int i = l; i < r; i++) {
            vec.push_back(seg->vec[i]);
            sorted.push_back(seg->vec[i]);
        }
        sort(sorted.begin(), sorted.end());
    }

    int get(int x) const {
        return upper_bound(sorted.begin(), sorted.end(), x) - sorted.begin();
    }
};

vector<Segment *> t;

int split(int pos) {
    for(size_t i = 0; i < t.size(); i++) {
        if(pos < (int)t[i]->vec.size()) {
            if(pos == 0)
                return i;
            Segment *l = new Segment(t[i], 0, pos), *r = new Segment(t[i], pos, t[i]->vec.size());
            delete t[i];
            t.erase(t.begin() + i);
            t.insert(t.begin() + i, r);
            t.insert(t.begin() + i, l);
            return i + 1;
        }
        pos -= (int)t[i]->vec.size();
    }
    return t.size();
}

void add(int pos, int x) {
    a[n++] = x;
    int k = split(pos);
    t.insert(t.begin() + k, new Segment(n - 1, n));
}

void del(int pos) {
    int k = split(pos);
    split(pos + 1);
    delete t[k];
    t.erase(t.begin() + k);
}

int get(int l, int r, int x) {
    l = split(l);
    r = split(r + 1);
    int res = 0;
    while(l < r) {
        res += t[l]->get(x);
        l++;
    }
    return res;
}

void build() {
    for(int l = 0; l < n; l += K) {
        int r = min(l + K, n);
        t.push_back(new Segment(l, r));
    }
}

void rebuild() {
    size_t sum = 0;
    for(size_t i = 0; i < t.size(); i++) {
        for(size_t j = 0; j < t[i]->vec.size(); j++)
            a[sum + j] = t[i]->vec[j];
        sum += t[i]->vec.size();
    }
    n = sum;
    for(size_t i = 0; i < t.size(); i++)
        delete t[i];
    t.clear();
    build();
}

int main() {
    ios_base::sync_with_stdio(false);
    cin >> n;
    for(int i = 0; i < n; i++)
        cin >> a[i];
    build();
    char q;
    int m = 0;
    while(cin >> q) {
        if(q == '+') {
            int i, x;
            cin >> i >> x;
            add(i, x);
        }
        else if(q == '-') {
            int i;
            cin >> i;
            del(i);
        }
        else {
            int l, r, x;
            cin >> l >> r >> x;
            cout << get(l, r, x) << '\n';
        }
        m++;
        if(!(m % (2 * K)))
            rebuild();
    }
    return 0;
}
