#include <iostream>
#include <string>
#include <cstdlib>
#include <cstdio>
#include <algorithm>
#include <map>
#include <set>
#include <vector>
#include <cmath>
#include <cstring>
#include <queue>
#include <deque>
#include <functional>
#include <climits>

#define mp make_pair
#define mt(a, b, c) mp(a, mp(b, c))
#define ABS(a) (((a) > 0) ? (a) : (-(a)))
#define ZERO(x) memset((x), 0, sizeof(x))
#define X first
#define Y second

using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> ii;
typedef unsigned int uint;

const int N = (1 << 24) + 1;
const int len = (1 << 12);

uint a[N + len];
uint b[len + 2];

void add(int l, int r, uint x)
{
	int b_start_ind = (l - 1) / len;
	int b_end_ind = r / len;
	for (int i = b_start_ind + 1; i < b_end_ind; i++)
		b[i] += x;
	for (int i = l; i < (b_start_ind + 1) * len; i++)
		a[i] += x;
	for (int i = b_end_ind * len; i <= r; i++)
		a[i] += x;
}

uint A, B;
uint cur = 0;
uint nextRand()
{
	cur = cur * A + B;
	return cur >> 8;
}

ii get_segment()
{
	uint l = nextRand();
	uint r = nextRand();
	if (l > r) swap(l, r);
	return mp(l, r);
}

uint S[N + len];

int main()
{

	int m, q;

	cin >> m >> q;

	cin >> A >> B;
	for (int i = 0; i < m; i++)
	{
		uint x = nextRand();
		ii seg = get_segment();
		S[seg.first] += x;
		S[seg.second + 1] -= x;
	}

	uint c = 0;
	for (int i = 0; i < N; i++)
	{
		c += S[i];
		a[i] = c;
	}



	S[0] = 0;

	for (int i = 0; i < N; i++)
		S[i + 1] = S[i] + a[i];

	uint ans = 0;

	for (int i = 0; i < q; i++)
	{
		pair<uint, uint> seg = get_segment();
		ans += S[seg.second + 1] - S[seg.first];
	}

	cout << ans;

	return 0;
}