#include <iostream>
#include <string>
#include <cstdlib>
#include <cstdio>
#include <algorithm>
#include <map>
#include <set>
#include <vector>
#include <cmath>
#include <cstring>
#include <queue>
#include <deque>
#include <functional>
#include <climits>

#define mp make_pair
#define mt(a, b, c) mp(a, mp(b, c))
#define ABS(a) (((a) > 0) ? (a) : (-(a)))
#define ZERO(x) memset((x), 0, sizeof(x))
#define X first
#define Y second

using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> ii;
typedef unsigned int uint;

const int N = 100500;
int n;
int a[N];
ll ans;

struct Segment
{
	vector<int> b;
	vector<int> c;

	Segment()
	{
	}

	Segment(int x)
	{
		b.push_back(x);
		c.push_back(x);
	}

	void build()
	{
		c.assign(b.begin(), b.end());
		sort(c.begin(), c.end());
	}

	int count(int x)
	{
		return upper_bound(c.begin(), c.end(), x) - c.begin();
	}
};

vector<Segment*> T;

int split_segment(int ind, int pos)
{
	Segment* tail = new Segment();
	tail->b.assign(T[ind]->b.begin() + pos, T[ind]->b.end());
	T[ind]->b.erase(T[ind]->b.begin() + pos, T[ind]->b.end());
	T[ind]->build();
	tail->build();

	T.insert(T.begin() + ind + 1, tail);
	return ind+1;
}

int split(int i)
{
	int pos = 0;
	int ind = 0;
	while (pos < i)
	{
		pos += T[ind]->b.size();
		++ind;
	}
	if (pos > i)
	{
		pos -= T[--ind]->b.size();
	}

	if (pos == i)
	{
		return ind;
	}

	return split_segment(ind, i - pos);
}

void erase(int i)
{
	int j = split(i);
	split(i+1);
	T.erase(T.begin() + j);
}

void insert(int i, int x)
{
	int j = split(i);
	Segment* ne = new Segment(x);
	T.insert(T.begin() + j, ne);
}

int cnt(int l, int r, int x)
{
	int il = split(l);
	int ir = split(r+1);
	int sum = 0;
	for (int i = il; i < ir; ++i)
	{
		sum += T[i]->count(x);
	}
	return sum;
}

int main()
{
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	int n;
	cin >> n;
	for (int i = 0; i < n; ++i)
	{
		cin >> a[i];
	}

	int sn = sqrt(n + 0.0);
	int i = 0;
	for (; i < n; i += sn)
	{
		Segment* s = new Segment();
		s->b.assign(a + i, a + min(i + sn, n));
		s->build();
		T.push_back(s);
	}

	char op;
	while (cin >> op)
	{
		int pos;
		switch(op)
		{
		case '-':
			cin >> pos;
			erase(pos);
			break;
		case '+':
			int val;
			cin >> pos >> val;
			insert(pos, val);
			break;
		case '?':
			int l, r, x;
			cin >> l >> r >> x;
			cout << cnt(l, r, x) << endl;
			break;
		}
	}

	return 0;
}