#include <cstdio>
#include <iostream>
#include <vector>
#include <algorithm>
#include <cstring>
#include <string>
#include <cmath>
#include <map>
#include <set>
#include <climits>
#include <cassert>
#include <cctype>
#include <queue>
using namespace std;

typedef long long ll;
typedef double dbl;
typedef long double ld;

#define mp make_pair
#define pb push_back
#define sz(x) (int)x.size()
#define all(x) x.begin(),x.end()
#define X first
#define Y second

const ll maxn = 2000*100 + 10;

int a[maxn];
int n;

class Segment {
public:
	int l, r;
	vector <int> v;
	Segment (int _l, int _r) {
		l = _l;
		r = _r;
		v.assign(a + l, a + r);
		sort(all(v));
	}
	int get (int x) {
		return upper_bound(all(v), x) - v.begin();
	}
};

vector <Segment*> T;

int split (int ii) {
	int mi = 0;
	int cur = 0;
	for (int i = 0; i < sz(T); i++) {
		if (ii <= cur) {
			mi = i;
			break;
		}
		cur += T[i]->r - T[i]->l;
	}
	if (cur == ii)
		return mi;
	else {
		mi--;
		cur -= T[mi]->r - T[mi]->l;
		Segment * b = new Segment(T[mi]->l, T[mi]->l - cur + ii);
		Segment * c = new Segment(T[mi]->l - cur + ii, T[mi]->r);
		T[mi] = b;
		T.insert(T.begin() + mi + 1, c);
		return mi + 1;
	}
}

void Insert (int i, int x) {
	a[n++] = x;
	int j = split(i);
	T.insert(T.begin() + j, new Segment(n - 1, n));
}

void Erase (int i) {
	int j = split(i);
	split(i + 1);
	T.erase(T.begin() + j);
}

int Count (int l, int r, int x) {
	l = split(l);
	r = split(r + 1);
	int res = 0;
	while (l < r) 
		res += T[l++]->get(x);
	return res;
}
bool query (char c) {
	return (c == '+') || (c == '-') || (c == '?');
}

void rebuild () {
	int k = (int)sqrt((double)n);
	for (int i = 0; i < n; i += k)
		T.push_back(new Segment(i, min(i + k, n)));
}



int main() {
#ifdef _MBCS
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	cin >> n;
	for (int i = 0; i < n; i++)
		scanf("%d", &a[i]);
	getchar();

	rebuild();

	char c;
	while (query(c = getchar())) {
		if (c == '+') {
			int i, x;
			scanf("%d%d", &i, &x);
			Insert(i, x);
		}
		if (c == '-') {
			int i;
			scanf("%d", &i);
			Erase(i);
		}
		if (c == '?') {
			int l, r, x;	
			scanf("%d%d%d", &l, &r, &x);
			printf("%d\n", Count(l, r, x));
		}
		/*if (sz(T) >= 3*(int)sqrt((double)n))
			rebuild();*/
		getchar();
	}
	return 0;
}