#include <iostream>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <set>
#include <cstring>
#include <cstdio>
#include <vector>
using namespace std;

typedef long long ll;
typedef pair<int, int> ii;
template <class T> int size(const T &x) { return x.size(); }


int INF = 2147483647;

void print();

vector<int> arr;
struct segment {
    int l, r, m;
    int arrl, arrr;

    int *sorted;
    segment(int _l, int _r, int _arrl, int _arrr) {

        l = _l;
        r = _r;
        arrl = _arrl;
        arrr = _arrr;
        m = r - l + 1;

        //cout << "Creating segment on " << l << " to " << r << endl;

        //cout << "m = " << m << endl;
        sorted = new int[m];
        //cout << "created" << endl;

        for (int i = 0; i < m; i++) {
            sorted[i] = arr[i + arrl];
        }

        //for (int i = l; i <= r; i++) {
        //    sorted[i - l] = arr[i];
        //}

        sort(sorted, sorted + m);
    }

    int query(int x) {
        /*
        int cnt = 0;
        for (int i = 0; i < m; i++) {
            if (sorted[i] <= x) {
                cnt++;
            }
        }
        */

        /*
        for (int i = 1; i < m; i++) {
            assert(sorted[i-1] <= sorted[i]);
        }
        */

        int lo = 0,
            hi = m - 1;

        bool found = false;
        while (lo < hi) {
            int z = hi - (hi - lo) / 2;
            if (sorted[z] > x) {
                hi = z - 1;
            } else {
                lo = z;
                found = true;
            }
        }
        if (sorted[hi] <= x) {
            found = true;
        }

        int res = found ? hi + 1 : 0;
        //printf("%d %d, %d %d\n", lo, hi, res, cnt);
        //assert(res == cnt);
        return res;
    }
};

int K, n;
vector<segment*> T;
void build() {
    T.clear();
    K = static_cast<int>(ceil(sqrt(n)) + 1e-9);
    //cout << K << endl;
    //cout << "n = " << n << ", K = " << K << endl;
    for (int i = 0; i < n; i += K) {
        int r = min(n - 1, i + K - 1);
        T.push_back(new segment(i, r, i, r));
    }
}

int split(int at) {

    if (size(T) > 3 * K) {
        build();
    }

    int s = -1;
    for (int i= 0 ; i < size(T); i++) {
        if (T[i]->l <= at && at <= T[i]->r) {
            s = i;
            break;
        }
    }

    //cout << "looking for " << at << " in:" << endl;
    //print();
    //cout << endl;
    //cout << "at " << s << endl;

    assert(s != -1 && T[s]->l <= at && at <= T[s]->r);

    if (T[s]->l == at)
        return s;

    int old_l = T[s]->l;
    int old_r = T[s]->r;
    int old_arrl = T[s]->arrl;
    int old_arrr = T[s]->arrr;

    delete T[s];
    T[s] = new segment(old_l, at - 1, old_arrl, old_arrl + at - old_l - 1);
    T.insert(T.begin() + s+1, new segment(at, old_r, old_arrl + at - old_l, old_arrr));
    return s + 1;
}

void print() {
    printf("Tree:----------------\n");
    for (int i = 0; i < size(T); i++) {
        printf("%d %d, %d %d\n", T[i]->arrl, T[i]->arrr, T[i]->l, T[i]->r);
    }
    printf("\n");
}

int realn;

int main() {
    scanf("%d\n", &n);

    arr = vector<int>(n);
    for (int i = 0; i < n; i++) {
        scanf("%d", &arr[i]);
    }

    scanf("\n");
    realn = n;

    //print();
    build();
    //print();

    char op;
    while (scanf("%c ", &op) != EOF) {
        if (op == '+') {
            int i, x;
            scanf("%d %d\n", &i, &x);
            //i--;

            //cout << "QUERYING + " << i << " " << x << endl;

            int s;
            if (i >= realn) {
                arr.push_back(x);
                n = size(arr);
                T.push_back(new segment(i, i, n-1, n-1));
                s = size(T) - 1;
            } else {
                arr.push_back(x);
                n = size(arr);

                s = split(i);
                T.insert(T.begin() + s, new segment(i, i, n-1, n-1));
            }

            for (int j = 0; j < size(T); j++) {
                if (j == s)
                    continue;
                if (i <= T[j]->l) {
                    T[j]->l++;
                    T[j]->r++;
                }
            }

            //cout << "DONE:" << endl;
            //print();
            realn++;

        } else if (op == '-') {
            int i;
            scanf("%d\n", &i);
            //i--;

            //cout << "QUERYING - " << i << endl;

            int a = split(i);
            int b = split(i+1);
            T.erase(T.begin() + a);
            for (int j = 0; j < size(T); j++) {
                if (T[j]->l >= i) {
                    T[j]->l--;
                    T[j]->r--;
                }
            }

            //cout << "DONE:" << endl;
            //print();
            realn--;

        } else if (op == '?') {
            int l, r, x;
            scanf("%d %d %d\n", &l, &r, &x);
            //l--, r--;

            //cout << "QUERYING ? " << l << " " << r << " " << x << endl;

            split(l);
            if (r + 1 < n) {
                split(r+1);
            }
            int cnt = 0;
            for (int i = 0; i < size(T); i++) {
                if (l <= T[i]->l && T[i]->r <= r) {
                    cnt += T[i]->query(x);
                }
            }

            printf("%d\n", cnt);

        } else {
            assert(false);
        }
    }

    return 0;
}

