#ifdef SU1
//#define _GLIBCXX_DEBUG
#endif

#include <algorithm>
#include <bitset>
#include <cassert>
#include <climits>
#include <cstring>
#include <cstdio>
#include <ctime>
#include <cstdlib>
#include <cmath>
#include <fstream>
#include <iostream>
#include <iomanip>
#include <list>
#include <map>
#include <numeric>
#include <queue>
#include <stack>
#include <set>
#include <string>
#include <utility>
#include <vector>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); i++)
#define forl(i, n) for (int i = 1; i <= int(n); i++)
#define ford(i, n) for (int i = int(n) - 1; i >= 0; i--)
#define fore(i, l, r) for (int i = int(l); i <= int(r); i++)
#define pb(a) push_back(a)
#define mp(x, y) make_pair((x), (y))
#define sz(a) (int) (a).size()
#define all(a) (a).begin(), (a).end()
#define ft first
#define sc second
#define x first
#define y second

template<typename X> inline X abs(const X& a) { return a < 0 ? -a : a; }
template<typename X> inline X sqr(const X& a) { return a * a; }

typedef long long li;
typedef long double ld;
typedef pair<int, int> pt;

const int INF = int(1e9) + 300;
const li INF64 = li(1e18);
const ld PI = acosl(ld(-1));
const ld EPS = 1e-9;

int myrand() {
	return abs((rand() << 16) ^ rand());
}

const int N = 200500;
int n;
pair<pt,int> a[N];
int w, h;

inline bool read()
{
	assert(scanf("%d%d", &w, &h) == 2);
	assert(scanf("%d", &n) == 1);
	forn(i, n) {
		assert(scanf("%d%d", &a[i].x.x, &a[i].x.y) == 2);
//		a[i].x.x = myrand() % w;
//		a[i].x.y = myrand() % max(1, h);
		if (a[i].x.x == 0 || a[i].x.y == 0 || a[i].x.x == w || a[i].x.y == h) {
			i--; n--;
		}
	}
	return true;
}

set<int> q;
int cnt[N];
inline void ins(int x, int idx) {
//	assert(idx >= 0);
	//cerr << "INS " << x << endl;
	if (cnt[idx] == 0) {
		q.insert(x);
	}
	cnt[idx]++;
}

int dd;
bool good;
pt ans;
int curX;
inline void del(int x, int idx) {
//	assert(idx >= 0);
	//cerr << "DEL " << x << endl;
	cnt[idx]--;
	if (cnt[idx] == 0) {
		set<int>::iterator it = q.upper_bound(x);
		int x3 = h;
		if (it != q.end())
			x3 = *it;
//		int x2 x;
		--it;
		--it;
		int x1 = *it;
		int nlen = x3 - x1;
		if (nlen >= dd) {
			good = true;
			ans = pt(curX, x1);
		}
		q.erase(x);
	}
}

int ys[N], szys = 0;

inline bool ok(int d) {
	if (d == 1) {
		ans = pt(0, 0);
		return true;
	}
	q.clear();
	q.insert(0);
	forn(i, szys)
		cnt[i] = 0;
	int i = 0;
	//cerr << "(" << endl;
	while (i < n && a[i].x.x < d) {
		ins(a[i].x.y, a[i].y);
		i++;
	}
	//cerr << ")" << endl;
	good = false;
	for (set<int>::iterator it = q.begin(); it != q.end(); ++it) {
		set<int>::iterator jt = it;
		jt++;
		int len = h - *it;
		if (jt != q.end())
			len = (*jt) - (*it);
		if (len >= d) {
			good = true;
			ans = pt(0, *it);
			break;
		}
	}
	dd = d;
	int j = 0;
	while (!good) {
		curX = a[j].x.x;
		if (curX + d > w) break;
//		cerr << a[i].x.x << ' ' << a[j].x.x << endl;
//		cerr << i << ' ' << j << endl;
		//cerr << curX << endl;
		if (a[j].x.x + d - 1 < a[i].x.x) {
			del(a[j].x.y, a[j].y);
			j++;
		} else {
			if (i == n) break;
			ins(a[i].x.y, a[i].y);
			i++;
		}
	}
	return good;
}

inline void solve()
{
	sort(a, a + n);
	forn(i, n)
		ys[szys++] = (a[i].x.y);
	sort(ys, ys + szys);
	szys = unique(ys, ys + szys) - ys;
	forn(i, n) {
		a[i].y = int(lower_bound(ys, ys + szys, a[i].x.y) - ys);
		assert(a[i].y >= 0);
	}
	a[n].x.x = INF;
	a[n].x.y = 0;
	a[n].y = -1;
	
	int lf = 0, rg = min(w, h) + 1;
	pair<int,pt> lastAns(0, pt(0, 0));
	while (lf + 1 < rg) {
//		if (clock() / ld(CLOCKS_PER_SEC) > 1.95)
//			break;
		int mid = (lf + rg) / 2;
		if (ok(mid)) {
			lf = mid;
			lastAns = max(lastAns, mp(mid, ans));
		} else {
			rg = mid;
		}
	}
	printf("%d\n", lastAns.x);
	printf("%d %d\n", lastAns.y.x, lastAns.y.y);
}

int main()
{
#ifdef SU1
	assert(freopen("input.txt", "rt", stdin));
//	assert(freopen("output.txt", "wt", stdout));
#endif

	cout << fixed << setprecision(10);
	cerr << fixed << setprecision(5);

	assert(read());
	solve();
	
#ifdef SU1
	cerr << "=== TIME : " << clock() << " ===" << endl;
#endif
	return 0;
}
