#include <stdio.h>
#include <string.h>
#include <math.h>

#include <algorithm>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <vector>
#include <queue>
#include <deque>
#include <iostream>

using namespace std;
int n, m, initial[200100], ind[200100], L[200100], R[200100], Val[200100], aib[200100], sol;
char op[200100];
vector <int> A[800100], aux;

inline void Aduna(int poz, int val)
{
    while(poz <= m)
    {
        aib[poz] += val;
        poz += (poz & -poz);
    }
}

inline int Suma(int poz)
{
    int rez = 0;
    while(poz > 0)
    {
        rez += aib[poz];
        poz -= (poz & -poz);
    }
    return rez;
}

inline int CautareBinaraInsert(int poz)
{
    int st, dr, mij, rez, s;
    st = 1;
    dr = m;
    rez = m;
    while(st <= dr)
    {
        mij = (st + dr) / 2;
        s = Suma(mij);
        if(s >= poz)
        {
            rez = mij;
            dr = mij - 1;
        }
        else
            st = mij + 1;
    }
    return rez;
}

inline void Build(int nod, int st, int dr)
{
    for(int i = st; i <= dr; ++i)
        A[nod].push_back(2000000000);
    if(st == dr)
        return;
    int mij = (st + dr) / 2;
    Build(2 * nod, st, mij);
    Build(2 * nod + 1, mij + 1, dr);
}

inline void Update(int nod, int st, int dr, int poz, int val)
{
    if(st == dr)
    {
        A[nod].clear();
        A[nod].push_back(val);
        return;
    }
    int mij = (st + dr) / 2;
    if(poz <= mij)
        Update(2 * nod, st, mij, poz, val);
    else
        Update(2 * nod + 1, mij + 1, dr, poz, val);
    vector <int>::iterator it, jt;
    it = A[2 * nod].begin();
    jt = A[2 * nod + 1].begin();
    A[nod].clear();
    while(it != A[2 * nod].end() && jt != A[2 * nod + 1].end())
    {
        if(*it < *jt)
        {
            A[nod].push_back(*it);
            it++;
        }
        else
        {
            A[nod].push_back(*jt);
            jt++;
        }
    }
    while(it != A[2 * nod].end())
    {
        A[nod].push_back(*it);
        it++;
    }
    while(jt != A[2 * nod + 1].end())
    {
        A[nod].push_back(*jt);
        jt++;
    }
}

inline void Query(int nod, int st, int dr, int LL, int RR, int val)
{
    if(LL <= st && dr <= RR)
    {
        int poz = upper_bound(A[nod].begin(), A[nod].end(), val) - A[nod].begin();
        sol += poz;
        return;
    }
    int mij = (st + dr) / 2;
    if(LL <= mij)
        Query(2 * nod, st, mij, LL, RR, val);
    if(mij + 1 <= RR)
        Query(2 * nod + 1, mij + 1, dr, LL, RR, val);
}

int main ()
{
#ifdef local
    freopen ("c.in", "r", stdin);
    freopen ("", "w", stdout);
#endif
    int i, x, st, dr;
    cin >> n;
    for(i = 1; i <= n; ++i)
    {
        cin >> initial[i];
        m++;
        op[m] = '+';
        ind[m] = i;
        Val[m] = initial[i];
    }
    while(cin >> op[++m])
    {
        if(op[m] == '+')
        {
            cin >> i >> x;
            i++;
            Val[m] = x;
            ind[m] = i;
        }
        if(op[m] == '-')
        {
            cin >> i;
            i++;
            ind[m] = i;
        }
        if(op[m] == '?')
        {
            cin >> st >> dr >> x;
            st++;
            dr++;
            L[m] = st;
            R[m] = dr;
            Val[m] = x;
        }
    }
    m--;
    for(i = 1; i <= m; ++i)
        Aduna(i, 1);
    for(i = m; i > 0; --i)
        if(op[i] == '+')
            ind[i] = CautareBinaraInsert(ind[i]);
    Build(1, 1, m);
    for(i = 0; i <= m; ++i)
        aib[i] = 0;
    for(i = 1; i <= m; ++i)
    {
        if(op[i] == '+')
        {
            Update(1, 1, m, ind[i], Val[i]);
            Aduna(ind[i], 1);
        }
        if(op[i] == '-')
        {
            ind[i] = CautareBinaraInsert(ind[i]);
            Aduna(ind[i], -1);
            Update(1, 1, m, ind[i], 2000000000);
        }
        if(op[i] == '?')
        {
            L[i] = CautareBinaraInsert(L[i]);
            R[i] = CautareBinaraInsert(R[i]);
            sol = 0;
            Query(1, 1, m, L[i], R[i], Val[i]);
            cout << sol << "\n";
        }
    }
    return 0;
}
