#include <iostream>
#include <vector>
#include <climits>

using namespace std;

typedef long long int Z;

const int N = 1 << 17;
int A[N];
int T[N];

int q(int a, int b) {
	int ret;
	if(A[a] < A[b]) {
		ret = a;
	} else {
		ret = b;
	}
	if(b - a <= 1) return ret;
	a += N;
	b += N;
	if(a % 2 == 0 && A[a + 1 - N] < A[ret]) ret = a + 1 - N;
	if(b % 2 == 1 && A[b - 1 - N] < A[ret]) ret = b - 1 - N;
	a /= 2;
	b /= 2;
	while(a / 2 != b / 2) {
		if(a % 2 == 0 && A[T[a + 1]] < A[ret]) ret = T[a + 1];
		if(b % 2 == 1 && A[T[b - 1]] < A[ret]) ret = T[b - 1];
		
		a /= 2;
		b /= 2;
	}
	
	return ret;
}

Z fds(int a, int b) {
	if(b < a) return 0;
	Z m = q(a, b);
	Z ret = (Z)A[m] * ((Z)(m - a + 1) * (Z)(b - m + 1));
	ret += fds(a, m - 1);
	ret += fds(m + 1, b);
	return ret;
}

int main() {
	cin.sync_with_stdio(false);
	
	int n;
	cin >> n;
	for(int i = 0; i < n; ++i) {
		cin >> A[i];
	}
	
	for(int i = N - 1; i != 0; --i) {
		int l = 2 * i;
		int r = l + 1;
		if(l >= N) {
			l -= N;
			r -= N;
			if(A[l] < A[r]) {
				T[i] = l;
			} else {
				T[i] = r;
			}
		} else {
			if(A[T[l]] < A[T[r]]) {
				T[i] = T[l];
			} else {
				T[i] = T[r];
			}
		}
	}
	
	cout << fds(0, n - 1) << "\n";
	
	return 0;
}
