#include <iostream>
#include <vector>
#include <climits>
#include <algorithm>

using namespace std;

typedef long long int Z;

struct V {
	vector<int> vals;
	vector<int> sorted;
};

int X = 320;
vector<V> vs;

void recompute() {
	vector<V> oldvs;
	swap(oldvs, vs);
	
	for(V& v : oldvs) {
	for(int x : v.vals) {
		if(vs.empty() || vs.back().vals.size() == X) vs.emplace_back();
		vs.back().vals.push_back(x);
		vs.back().sorted.push_back(x);
	}
	}
	for(V& v : vs) sort(v.sorted.begin(), v.sorted.end());
}

int main() {
	cin.sync_with_stdio(false);
	
	int n;
	cin >> n;
	
	for(int i = 0; i < n; ++i) {
		if(vs.empty() || vs.back().vals.size() == X) vs.emplace_back();
		int x;
		cin >> x;
		vs.back().vals.push_back(x);
		vs.back().sorted.push_back(x);
	}
	for(V& v : vs) sort(v.sorted.begin(), v.sorted.end());
	
	int cnt = 0;
	while(true) {
		if(cnt == X) recompute();
		
		char t;
		cin >> t;
		if(!cin.good()) break;
		if(t == '+') {
			int i, x;
			cin >> i >> x;
			int start = 0;
			for(V& v : vs) {
				int end = start + v.vals.size();
				
				if(i >= start && i <= end) {
					i -= start;
					v.vals.insert(v.vals.begin() + i, x);
					v.sorted.push_back(x);
					sort(v.sorted.begin(), v.sorted.end());
					break;
				}
				
				start = end;
			}
			++cnt;
		} else if(t == '-') {
			int i;
			cin >> i;
			int start = 0;
			for(V& v : vs) {
				int end = start + v.vals.size();
				
				if(i >= start && i < end) {
					i -= start;
					int val = v.vals[i];
					v.vals.erase(v.vals.begin() + i);
					v.sorted.erase(lower_bound(v.sorted.begin(), v.sorted.end(), val));
					break;
				}
				
				start = end;
			}
			++cnt;
		} else {
			int L, R, x;
			cin >> L >> R >> x;
			++R;
			int start = 0;
			int ret = 0;
			for(V& v : vs) {
				int end = start + v.vals.size();
				
				int a = min(R, max(L, start));
				int b = min(R, max(L, end));
				
				a -= start;
				b -= start;
				
				if(a < b) {
					if(a == 0 && b == v.vals.size()) {
						ret += upper_bound(v.sorted.begin(), v.sorted.end(), x) - v.sorted.begin();
					} else {
						for(int i = a; i < b; ++i) {
							int y = v.vals[i];
							if(y <= x) {
								++ret;
							}
						}
					}
				}
				
				start = end;
			}
			cout << ret << "\n";
		}
		
		/*for(V& v : vs) {
			cout << "[ ";
			for(int x : v.vals) {
				cout << x << ' ';
			}
			cout << "] ";
		}
		cout << "\n";
		for(V& v : vs) {
			cout << "[ ";
			for(int x : v.sorted) {
				cout << x << ' ';
			}
			cout << "] ";
		}
		cout << "\n";*/
	}
	
	return 0;
}
