#include <stdio.h>
#include <algorithm>
#include <vector>
#include <memory.h>
#include <iostream>

using namespace std;

const int C = 333;

struct Segment {
	vector<int> a, b;
	Segment() {}
	Segment(vector<int> v) {
		a = b = v;
		sort(a.begin(), a.end());
	}
	Segment(int x) {
		a.resize(1);
		b.resize(1);
		a[0] = b[0] = x;
	}
};

int n;
vector<Segment*> segs;

int split(int x) {
	int cur = 0;
	int e = segs.size();
	for (int i = 0; i < segs.size(); i++) {
		if (x < cur + (segs[i] -> a).size()) {
			e = i;
			break;
		}
		cur += (segs[i] -> a).size();
	}
	if (cur == x) return e;
	vector<int> v0(x - cur);
	vector<int> v1(cur + (segs[e] -> b).size() - x);
	for (int i = 0; i < (segs[e] -> b).size();  i++) {
		if (i < v0.size())
			v0[i] = (segs[e] -> b)[i];
		else v1[i - v0.size()] = (segs[e] -> b)[i];
	}
	(segs[e] -> a).clear();
	(segs[e] -> b).clear();
	delete segs[e];	
	segs.erase(segs.begin() + e);
	segs.insert(segs.begin() + e, new Segment(v1));
	segs.insert(segs.begin() + e, new Segment(v0));
	return e + 1;
}

void rebuild() {
	vector<int> v;
	for (int i = 0; i < segs.size(); i++) {
		v.insert(v.end(), (segs[i] -> b).begin(), (segs[i] -> b).end());
	}
	for (int i = 0; i < segs.size(); i++) {
		(segs[i] -> a).clear();
		(segs[i] -> b).clear();
		delete segs[i];
	}
	segs.clear();
	segs.push_back(new Segment(v));
}

int main() {
	freopen("kthstat.in", "r", stdin);
	scanf("%d", &n);
	vector<int> v(n);
	for (int i = 0; i < n; i++) scanf("%d", &v[i]);
	segs.push_back(new Segment(v));
	scanf("\n");
	char qc;
	while (scanf("%c", &qc) == 1) {
		if (qc == '?') {
			int l, r, x;
			scanf("%d%d%d\n", &l, &r, &x);
			r++;
			l = split(l);
			r = split(r);
			int ans = 0;
			while (l < r) {
				ans += lower_bound((segs[l] -> a).begin(), (segs[l] -> a).end(), x + 1) - (segs[l] -> a).begin();
				l++;
			}
			printf("%d\n", ans);
		} else  if (qc == '-') {
			int x;
			scanf("%d\n", &x);
			int y = x + 1;
			x = split(x);
			y = split(y);
			(segs[x] -> a).clear();
			(segs[x] -> b).clear();
			delete segs[x];
			segs.erase(segs.begin() + x);
		} else if (qc == '+') {
			int u, x;
			scanf("%d%d\n", &u, &x);
			u = split(u);
			segs.insert(segs.begin() + u, new Segment(x));
		} else break;
		if (segs.size() > C) rebuild();
	}
}
