#include <stdio.h>
#include <algorithm>
#include <vector>
#include <memory.h>
#include <iostream>

using namespace std;

const int C = 344;
const int N = 500050;

struct Segment {
	vector<int> a, b;
	Segment() {}
	Segment(vector<int> v) {
		a = b = v;
		sort(a.begin(), a.end());
	}
	Segment(int x) {
		a.resize(1);
		b.resize(1);
		a[0] = b[0] = x;
	}
};

int n, cmem;
Segment mem[N];
vector<int> freemem;
vector<int> segs;

int getfree() {
	int x = freemem.back();
	freemem.pop_back();
	return x;
}

void ers(int x) {
	freemem.push_back(x);
}

int split(int x) {
	int cur = 0;
	int e = segs.size();
	for (int i = 0; i < segs.size(); i++) {
		if (x < cur + mem[segs[i]].a.size()) {
			e = i;
			break;
		}
		cur += mem[segs[i]].a.size();
	}
	if (cur == x) return e;
	vector<int> v0(x - cur);
	vector<int> v1(cur + mem[segs[e]].b.size() - x);
	for (int i = 0; i < mem[segs[e]].b.size();  i++) {
		if (i < v0.size())
			v0[i] = mem[segs[e]].b[i];
		else v1[i - v0.size()] = mem[segs[e]].b[i];
	}
	mem[segs[e]].a.clear();
	mem[segs[e]].b.clear();
	ers(segs[e]);
	segs.erase(segs.begin() + e);
	cmem = getfree();
	mem[cmem] = Segment(v1);
	segs.insert(segs.begin() + e, cmem++);
	cmem = getfree();
	mem[cmem] = Segment(v0);
	segs.insert(segs.begin() + e, cmem++);
	return e + 1;
}

void rebuild() {
	vector<int> v;
	for (int i = 0; i < segs.size(); i++) {
		v.insert(v.end(), mem[segs[i]].b.begin(), mem[segs[i]].b.end());
	}
	for (int i = 0; i < segs.size(); i++) {
		mem[segs[i]].a.clear();
		mem[segs[i]].b.clear();
		ers(segs[i]);
	}
	segs.clear();
	cmem = getfree();
	mem[cmem] = Segment(v);
	segs.push_back(cmem++);
}

int main() {
	freopen("kthstat.in", "r", stdin);
	scanf("%d", &n);
	vector<int> v(n);
	for (int i = 0; i < n; i++) scanf("%d", &v[i]);
	freemem.resize(n + 5);
	for (int i = 0; i < freemem.size(); i++) freemem[i] = i;
	cmem = getfree();
	mem[cmem] = Segment(v);
	segs.push_back(cmem);
	scanf("\n");
	char qc;
	while (scanf("%c", &qc) == 1) {
		if (qc == '?') {
			int l, r, x;
			scanf("%d%d%d\n", &l, &r, &x);
			r++;
			l = split(l);
			r = split(r);
			int ans = 0;
			while (l < r) {
				ans += lower_bound(mem[segs[l]].a.begin(), mem[segs[l]].a.end(), x + 1) - mem[segs[l]].a.begin();
				l++;
			}
			printf("%d\n", ans);
		} else  if (qc == '-') {
			int x;
			scanf("%d\n", &x);
			int y = x + 1;
			x = split(x);
			y = split(y);
			mem[segs[x]].a.clear();
			mem[segs[x]].b.clear();
			ers(segs[x]);
			segs.erase(segs.begin() + x);
		} else if (qc == '+') {
			int u, x;
			scanf("%d%d\n", &u, &x);
			u = split(u);
			cmem = getfree();
			mem[cmem] = Segment(x);
			segs.insert(segs.begin() + u, cmem++);
		} else break;
		if (segs.size() > C) rebuild();
	}
}
