#include <iostream>
#include <cstdio>
#include <vector>
#include <set>
#include <string>
#include <cstring>
#include <algorithm>
using namespace std;


const int maxn = 200500;

int x, y;
int n;
int X[maxn], Y[maxn];
int allY[maxn];
int cntY;

int ansX, ansY;
multiset <int> Ys;


struct Event
{
	int x, y, type;
	Event() : x(), y(), type() {}
	Event(int _x, int _y, int _type) : x(_x), y(_y), type(_type) {}

	bool operator < (const Event &A) const
	{
		if (x != A.x)
			return x < A.x;
		if (type != A.type)
			return type < A.type;
		return y < A.y;
	}
};


void insertY(int y)
{
	Ys.insert(y);
}
bool eraseY(int x, int y, int side)
{
	multiset <int>::iterator yit, pit, nit;
	yit = Ys.find(y);
	pit = yit;
	nit = yit;
	pit--;
	nit++;
	int yup = *nit;
	int ydown = *pit;
	Ys.erase(yit);
	if (yup - ydown >= side)
	{
		ansX = x;
		ansY = ydown;
		return true;
	}
	return false;
}

bool testAll(int side)
{
//	printf("testAll: ");
	for (multiset <int>::iterator it = Ys.begin(); it != Ys.end(); it++)
	{
//		printf("%d ", *it);
		multiset <int>::iterator nit = it;
		nit++;
		if (nit == Ys.end() )
			continue;
		int ydown = *it;
		int yup = *nit;
		if (yup - ydown >= side)
		{
			ansX = 0;
			ansY = ydown;
//			printf("\n");
			return true;
		}
	}
//	printf("\n");
	return false;
}

bool test(int side)
{
	Ys.clear();
	vector <Event> ev;
	
	ev.push_back(Event(-1, 0, 1) );
	ev.push_back(Event(-1, y, 1) );
	
	for (int i = 0; i < n; i++)
	{
		ev.push_back(Event(X[i] - side, Y[i], 1) );
		ev.push_back(Event(X[i], Y[i], -1) );
	}
	ev.push_back(Event(0, -1, 0) );
	sort(ev.begin(), ev.end() );
	

//	printf("side = %d\n", side);

	
	bool tested = false;
	for (int i = 0; i < (int) ev.size(); i++)
	{
//		printf("%d: %d, %d, %d\n", i, ev[i].x, ev[i].y, ev[i].type);
		int type = ev[i].type;
		if (!tested && ev[i].x == 0)
		{
			if (testAll(side) )
				return true;
			tested = true;
		}
		if (x - ev[i].x < side)
			break;
		if (type == 1)
		{
			insertY(ev[i].y);
		}
		else if (type == -1)
		{
			if (eraseY(ev[i].x, ev[i].y, side) )
				return true;
		}
	}

	return false;
}



int main()
{
	freopen("roi.in", "r", stdin);
	freopen("roi.out", "w", stdout);

	scanf("%d%d", &x, &y);
	scanf("%d", &n);
	int cntGood = 0;
	for (int i = 0; i < n; i++)
	{
		scanf("%d%d", &X[cntGood], &Y[cntGood] );
		allY[cntGood] = Y[cntGood];
		if (X[cntGood] == 0 || Y[cntGood] == 0 || X[cntGood] == x || Y[cntGood] == y)
			continue;
		cntGood++;
	}
	n = cntGood;
	allY[n] = 0;
	allY[n + 1] = y;
	sort(allY, allY + n + 2);
	cntY = unique(allY, allY + n + 2) - allY;
	
	int lb = 1;
	int rb = min(x, y) + 1;

	while (rb - lb > 1)
	{
		int mid = (lb + rb) / 2;
		if (test(mid) )
			lb = mid;
		else
			rb = mid;
	}
	test(lb);
	printf("%d\n", lb);
	printf("%d %d\n", ansX, ansY);


	return 0;
}

