#include <iostream>
#include <fstream>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <iomanip>
#include <algorithm>
#include <queue>

#define TASK "task"

#define MAX_N 100000
#define MAX_CONTAINERS 330

typedef long long ll;
typedef long double ld;

using namespace std;

int n;
int a[MAX_N];


int numInterv;
int s;//interv size

int minS[MAX_CONTAINERS];

//pair<int, int> p[MAX_N];

ll answer;

int sFirst(int i) {
	return min(i*s, n);
}

int sLast(int i) {
	return min((i+1)*s, n);
}

int getSNr(int x) {
	return x / s;
}


int res;
int getMin(int start, int end) {
	//cout << "begin" << endl;
	//cout << "getMin " << start << " - " << end << endl;
	int sStart = getSNr(start);
	int sEnd = getSNr(end);
	//cout << sStart << "_" << sEnd << endl;
	int min = -1;

	if (sStart == sEnd) {
		//in one interval
		min = start;
		for (int i = start+1; i <= end; ++i)
			if (a[i] < a[min])
				min = i;
	}
	else {
		int limit;
		//head
		limit = sLast(sStart);
		for (int i = start; i < limit; ++i)
			if (min == -1 || a[i] < a[min])
				min = i;
		//tail
		limit = sFirst(sEnd);
		for (int i = limit; i <= end; ++i)
			if (min == -1 || a[i] < a[min])
				min = i;
	}

	for (int i = start+1; i < sEnd; ++i)
		if (min == -1 || a[minS[i]] < a[min])
			min = minS[i];
	
	//cout << "end" << endl;
	return min;
}

queue<pair<int, int> > q;

int main() {
	//freopen(TASK".in", "r", stdin);
	//freopen(TASK".out", "w", stdout);

	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		//p[i].first = a[i];
		//p[i].second = i;
	}
	s = sqrt(double(n));
	while (s*s < n)
		s++;
	numInterv = s;
	while ((numInterv-1) * s >= n)
		numInterv--;

	for (int i = 0; i < numInterv; ++i) {
		int start = sFirst(i);
		int end = sLast(i);
		if (start < end) {
			//cout << i << ": " << start << " - " << end-1 << endl;
			int min = start;
			for (int j = start+1; j < end; ++j)
				if (a[j] < a[min])
					min = j;
			minS[i] = min;
		}
	}

	//for (int i = 0; i < n; ++i)
		//cout << "[" << 0 << "; " << i << "] = " << getMin(0, i) << endl;

	ll answer = 0;

	q.push(make_pair(0, n-1));
	while (!q.empty()) {
		//cout << "." << endl;
		pair<int, int> pair = q.front();
		q.pop();
		if (pair.first == pair.second) {
			//cout << "+single " << a[pair.first] << endl;
			answer += (ll)a[pair.first];
		}
		else if (pair.first > pair.second) {
			//skip
		}
		else {
			int min = getMin(pair.first, pair.second);
			//cout << "min=" << min << endl;
			ll lx = min - pair.first;
			ll ly = pair.second - min;
			//cout << "times=" << ( (lx * (ly+1)) + (ly * (lx+1)) + 1 ) << endl;
			//int times = ( (lx * (ly+1)) + (ly * (lx+1)) + 1 );
			ll times = (ll)1 + lx + ly + lx*ly;
			answer += (ll)a[min] * times;
			//cout << "+interval " << a[min] * ( (lx * (ly+1)) + (ly * (lx+1)) + 1 ) << endl;
			q.push(make_pair(pair.first, min-1));
			q.push(make_pair(min+1, pair.second));
		}
	}


	//sort(p, p+n);
	/*
	for (int i = 0; i < n; ++i) {
		cout << p[i].first << endl;
		int pos = p[i].second;
		ll value = p[i].first;
		ll lx = pos - 0;
		ll ly = n-1 - pos;
		answer += value * ((lx * (ly+1)) + (ly * (lx+1)));
	}

	*/
	cout << answer << endl;
	
	return 0;
}