#if 1
#include <functional>
#include <algorithm>
#include <iostream>
#include <iterator>
#include <iomanip>
#include <sstream>
#include <numeric>
#include <string>
#include <vector>
#include <bitset>
#include <queue>
#include <stack>
#include <map>
#include <set>
#include <cstdlib>
#include <cassert>
#include <cstring>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <list>
 
using namespace std;
 
typedef long long LL;
typedef long double LD;
typedef pair<int, int> pii;
 
const LD eps = 1e-9;
const LD pi = acos(-1.0);
const LL inf = 1e+9;
 
#define mp make_pair
#define pb push_back
#define X first
#define Y second
 
#define dbg(x) { cerr << #x << " = " << x << endl; }
 
// extended template
#pragma comment(linker, "/STACK:36777216")
typedef vector<int> vi;
typedef vector<vi> vvi;
 
#define forn(i, n) for (int i = 0; i < n; ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
 
template<typename T> istream & operator >> (istream &, vector<T> &);
template<typename T> ostream & operator << (ostream &, const vector<T> &);
 
#define START clock_t _clock = clock();
#define END cerr << endl << "time: " << (clock() - _clock) / LD(CLOCKS_PER_SEC) << endl;
 
#define NAME "minsum"
#define MAXN 100010

int a[MAXN];
int n, L[MAXN], R[MAXN];

void readin(){
    scanf("%d", &n);
    for (int i = 1; i <= n; i++)
        scanf("%d", &a[i]);
}

void init(){
    stack<int> st;
    L[1] = 1;
    st.push(1);
    for (int i = 2; i <= n; i++){
        if (a[i] >= a[st.top()]){
            L[i] = i;
        } else{
            while (!st.empty() && a[i] < a[st.top()]){
                L[i] = L[st.top()];
                st.pop();
            }
        }
        st.push(i);
    }

    while (!st.empty()) st.pop();

    R[n] = n;
    st.push(n);
    for (int i = n - 1; i >= 1; i--){
        if (a[i] > a[st.top()]){
            R[i] = i;
        } else{
            while (!st.empty() && a[i] <= a[st.top()]){
                R[i] = R[st.top()];
                st.pop();
            }
        }
        st.push(i);
    }
}

void solve()
{
    readin();
    init();
    LL res = 0;
    for (int i = 1; i <= n; i++){
        LL x1 = R[i] - i + 1;
        LL x2 = i - L[i] + 1;
        res = res + x1 * x2 * a[i];
    }
    cout << res << endl;
}
 
int main()
{
    freopen(NAME ".in", "r", stdin); freopen(NAME ".out", "w", stdout);
    //freopen("input.txt", "r", stdin); // freopen("output.txt", "w", stdout);
 
    solve();
 
    return 0;
}
/*******************************************
*******************************************/
 
template<typename T> istream & operator >> (istream &is, vector<T> &v)
{
    forn(i, v.size())
        is >> v[i];
    return is;
}
template<typename T> ostream & operator << (ostream &os, const vector<T> &v)
{
    forn(i, v.size())
        os << v[i] << " ";
    return os;
}
#endif