#if 1
#include <functional>
#include <algorithm>
#include <iostream>
#include <iterator>
#include <iomanip>
#include <sstream>
#include <numeric>
#include <string>
#include <vector>
#include <bitset>
#include <queue>
#include <stack>
#include <map>
#include <set>
#include <cstdlib>
#include <cassert>
#include <cstring>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <list>
 
using namespace std;
 
typedef long long LL;
typedef long double LD;
typedef pair<int, int> pii;
 
const LD eps = 1e-9;
const LD pi = acos(-1.0);
const LL inf = 1e+9;
 
#define mp make_pair
#define pb push_back
#define X first
#define Y second
 
#define dbg(x) { cerr << #x << " = " << x << endl; }
 
// extended template
#pragma comment(linker, "/STACK:36777216")
typedef vector<int> vi;
typedef vector<vi> vvi;
 
#define forn(i, n) for (int i = 0; i < n; ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
 
template<typename T> istream & operator >> (istream &, vector<T> &);
template<typename T> ostream & operator << (ostream &, const vector<T> &);
 
#define START clock_t _clock = clock();
#define END cerr << endl << "time: " << (clock() - _clock) / LD(CLOCKS_PER_SEC) << endl;
 
#define NAME "problem"

int maxx, maxy;

vector<pii> pts;

queue<pii> q;
multiset<int> yy;
multiset<int> hh;

void add(const pii &p)
{
    yy.insert(p.Y);
    multiset<int>::iterator it = yy.upper_bound(p.Y);
    int top = it == yy.end() ? maxy : *it;
    multiset<int>::iterator jt = yy.lower_bound(p.Y);
    int bot = jt == yy.begin() ? 0 : *(--jt);

    int HH = top - bot;
    int h1 = top - p.Y;
    int h2 = p.Y - bot;

    if (hh.count(HH))
        hh.erase(hh.lower_bound(HH));
    
    hh.insert(h1);
    hh.insert(h2);
}

void del(const pii &p)
{
    yy.insert(p.Y);
    multiset<int>::iterator it = yy.upper_bound(p.Y);
    int top = it == yy.end() ? maxy : *it;
    multiset<int>::iterator jt = yy.lower_bound(p.Y);
    int bot = jt == yy.begin() ? 0 : *(--jt);

    int HH = top - bot;
    int h1 = top - p.Y;
    int h2 = p.Y - bot;

    hh.insert(HH);

    if (hh.count(h1))
        hh.erase(hh.lower_bound(h1));
    if (hh.count(h2))
        hh.erase(hh.lower_bound(h2));
}

int get_max()
{
    if (hh.size())
        return *(--hh.end());
    return maxy;
}

int x_coord = -1;
int y_coord = -1;

void upd_yy(int h)
{
    int prev = 0;
    for (multiset<int>::const_iterator it = yy.begin(); it != yy.end(); ++it)
    {
        int len = *it - prev;
        if (len >= h)
                y_coord = *it;

        prev = *it;
    }
}

bool check(int h, int val = 0)
{
    q = queue<pii>();
    hh.clear();
    yy.clear();

    bool fl = false;
    forn(i, pts.size())
    {
        q.push(pts[i]);
        add(pts[i]);

        if (pts[i].X >= h)
        {
            while (q.size() && (pts[i].X - q.front().X) > h)
            {
                pii p = q.front(); q.pop();
                del(p);
            }

            if (get_max() >= h)
            {
                if (val == 1)
                {
                    if (x_coord == -1 || x_coord <= pts[i].X)
                        x_coord = pts[i].X;
                }
                fl = true;
            }
        }
    }  

    if (val == 2)
    upd_yy(h);

    return fl;
}

void solve()
{
    int n; scanf("%d %d %d", &maxx, &maxy, &n);
    
    if (maxx == 0 || maxy == 0)
    {
        printf("0\n0 0\n");
        return;
    }
    
    pts.resize(n);
    forn(i, n)
        scanf("%d %d", &pts[i].X, &pts[i].Y);


    pts.push_back(mp(maxx, maxy));
    pts.push_back(mp(0, 0));
    pts.push_back(mp(maxx, 0));
    pts.push_back(mp(0, maxy));
    n += 4;

    forn(i, pts.size())
    {
        pts[i].X = maxx - pts[i].X;
        pts[i].Y = maxy - pts[i].Y;
    }


    sort(all(pts));

    //dbg(int(check(2)));


    int l = 0, r = inf + 100;
    while (r - l > 1)
    {
        int m = (l + r) / 2;
        if (check(m))
            l = m;
        else
            r = m;
    }

    // xx
    check(l, 1);

    // yy
    check(l, 2);

    //dbg(x_coord);
    //dbg(y_coord);

    printf("%d\n", l);
    printf("%d %d\n", maxx - x_coord, maxy - y_coord);
}
 
int main()
{
    // freopen(NAME ".in", "r", stdin); freopen(NAME ".out", "w", stdout);
    // freopen("input.txt", "r", stdin); // freopen("output.txt", "w", stdout);
 
    solve();
 
    return 0;
}
/*******************************************
*******************************************/
 
template<typename T> istream & operator >> (istream &is, vector<T> &v)
{
    forn(i, v.size())
        is >> v[i];
    return is;
}
template<typename T> ostream & operator << (ostream &os, const vector<T> &v)
{
    forn(i, v.size())
        os << v[i] << " ";
    return os;
}
#endif